/******************************************************************************/
/*                                                                            */
/*                               Creat.h                                      */
/*                           (Nov. 19, 1992)                                  */
/*                                                                            */
/*       This is the decleration file used in creating a dictionary.          */
/*                                                                            */
/******************************************************************************/


#include     <stdio.h>

#include     <string.h>




#define      MAXWORDLEN     80     /* Maximum length of a word */

#define      NUMOFBUCKET    8988  /* number of buckets w/ prefix of 3 chars */

#define      NUMOFCODE      371    /* number of different class codes */ 

#define      MAXBUCKET      10000  /* max number of words one bucket contains */

#define      NUMOFIDIOM     164691 /* number of idioms in idiom.dat */

#define      NUMOFWORDS     189836 /* number of words in word.dat */

#define      SIZEOFWDDAT    2339525 /* size of word.dat */

#define      SIZEOFWORDBK   30000 /* size of bckt.idx */

#define      WDIDXSIZE      447877/* size of word.idx */       

#define      MAXBKCONFLICT  6      /* max # of conflicts when search bckt name*/

#define      CNFLTPRCNT     0.20  /*  percentage of conflicts */

#define      TRUE           1      /* Boolean value TRUE */

#define      FALSE          0      /* Boolean value FALSE */ 

#define      PREFIXLEN      3      /* length of prefix considered */

#define      SUFFIXLEN      4      /* length of suffix considered */

#define      PRETAILLEN     4      /* prefix length of a word tail considered */

#define      READWRITE      "r+"

#define      READ           "r" 

#define      WRITE          "w"

#define      WORD           "/home/leibniz/zhao/originaldict/214100pos\0"

#define      BKNAME         "/home/leibniz/zhao/creat/bckt.nam\0"

#define      CODETABLE      "/home/leibniz/zhao/creat/class.dat\0"

#define      IDIOMDAT       "/home/leibniz/zhao/creat/idiom.dat\0"

#define      IDIOMLOC       "/home/leibniz/zhao/creat/idloc.dat\0"

#define      BCKTIDX        "/home/leibniz/navy/Laempel/Update/bckt.idx\0"

#define      WORDIDX        "/home/leibniz/navy/Laempel/Update/word.idx\0"

#define      WORDDAT        "/home/leibniz/navy/Laempel/Update/word.dat\0"

#define      IDIOMIDX       "/home/leibniz/zhao/creat/idiom.idx\0"



 




typedef      unsigned short boolean;




struct       BcktIdxEnt  { /* entry in the file "bckt.idx" */

                           char                bcktnm[PREFIXLEN + 1];
                           unsigned long int   bkloc;
                           unsigned            freq;
                           int                 bksize;
                           char                fnct;
                           int                 maxcnft;

                         };





struct       WordIdxEnt  { /* entry in the file "word.idx" */

                           unsigned            length; /* length of word */
                           unsigned long int   wdloc;  /* loc in "word.dat" */
                           unsigned            idmnum; /* # of related idioms */
                           unsigned long int   idmloc; /* loc in "idiom.idx" */

                         };




unsigned     ReadSucc, WriteSucc;


FILE         *word, *name, *code, *idiom, *idloc, *wdbkindex, *wdidx, *wddat,
             *idmidx, *wddatt;





