#include    "random.h"



int BcktHash(prefix)  

char  prefix[];

{
  unsigned long int   sum;
 
  sum = prefix[0] * 31 + prefix[2] * 83 * 83 + prefix[1] * 72 * 72 *72; 
  return(sum % SIZEOFWORDBK);
}
   


unsigned long int Hash1(suffix, size)

char       suffix[];
unsigned   size;


{
  unsigned long int   sum;


  sum = suffix[0] * 31 + suffix[2] * 83 * 83 + suffix[1] * 72 * 72 * 72 
        + suffix[3] * 95 * 91 * 97 * 73;
  return(sum % size);
}


  


int WordHash1(Word, size)  

char       Word[];
unsigned   size;





{
  unsigned            len, i, j;
  unsigned long int   val;
  char                suffix[SUFFIXLEN + 1];
  


  if ((len = strlen(Word)) <= PREFIXLEN)
  {
    return(0);
  }
  else
  {
    j = PREFIXLEN;
    for (i = 0; i < SUFFIXLEN; i++)
    {
      if (j < len)
      {
        suffix[i] = Word[j ++];
      }
      else
      {
        suffix[i] = ' ';
      };
    };
    suffix[i] ='\0';

    return(Hash1(suffix, size));
  };
   
}


      

    



unsigned long int Hash2(suffix, size)

char       suffix[];
unsigned   size;


{
  unsigned long int   sum;


  sum = suffix[1] * 11 + suffix[3] * 83 * 73 + suffix[2] * 72 * 79 * 53 
        + suffix[0] * 91 * 87 * 97 * 73;
  return(sum % size);
}


  


int WordHash2(Word, size)  

char       Word[];
unsigned   size;





{
  unsigned            len, i, j;
  unsigned long int   val1, val2;
  char                suffix[SUFFIXLEN + 1];
  char                pretail[PRETAILLEN + 1];




  if ((len = strlen(Word)) <= PREFIXLEN)
  {
    return(0);
  }
  else
  {
    if (len <= (PREFIXLEN + SUFFIXLEN))
    {
      j = PREFIXLEN;
      for (i = 0; i < SUFFIXLEN; i++)
      {
        if (j < len)
        {
          suffix[i] = Word[j ++];
        }
        else
        {
          suffix[i] = ' ';
        };
      };
      suffix[i] ='\0';
      
      val1 = Hash2(suffix, size);
      srand2(val1);
      return((rand2() * 10 * val1) % size);
    }
    else
    {
      j = PREFIXLEN;
      for (i = 0; i < PRETAILLEN; i++)
      {
        pretail[i] = Word[j ++];
      };
      pretail[i] = '\0';
      
      j = len - SUFFIXLEN;
      for (i = 0; i < SUFFIXLEN; i++)
      {
        suffix[i] = Word[j++];
      };
      suffix[i] = '\0';

      val1 = Hash2(pretail, size);
      srand2(val1);
      val1 = rand2() * 10 * val1;

      val2 = Hash2(suffix, size);
      srand2(val2);
      val2 = rand2() * 10 * val2;
      
      return((val1 + val2) % size);
    };
  };

}




unsigned long int Hash3(suffix, size)

char       suffix[];
unsigned   size;


{
  unsigned long int   sum;


  sum = suffix[0] * 41 + suffix[1] * 67 * 83 + suffix[2] * 72 * 59 * 72 
        + suffix[3] * 83 * 91 * 97 * 89;
  return(sum % size);
}


  


int WordHash3(Word, size)  

char       Word[];
unsigned   size;





{
  unsigned            len, i, j;
  unsigned long int   val;
  char                suffix1[SUFFIXLEN + 1], suffix2[SUFFIXLEN + 1];
  


  if ((len = strlen(Word)) <= PREFIXLEN)
  {
    return(0);
  }
  else
  {
    j = PREFIXLEN;
    for (i = 0; i < SUFFIXLEN; i++)
    {
      if (j < len)
      {
        suffix1[i] = Word[j ++];
        if (j < len)
        {
          suffix2[i] = Word[j ++];
        }
        else
        {
          suffix2[i] = ' ';
        };
      }
      else
      {
        suffix1[i] = ' ';
        suffix2[i] = ' ';
      };
    };
    suffix1[i] = '\0';
    suffix2[i] = '\0';

    return((Hash3(suffix1, size) + Hash3(suffix2, size)) % size);
  };
   
}






unsigned long int Hash4(suffix, size)

char       suffix[];
unsigned   size;


{
  unsigned long int   sum;


  sum = suffix[3] * 31 + suffix[2] * 93 * 83 + suffix[1] * 72 * 83 * 62 
        + suffix[0] * 95 * 93 * 97 * 99;
  return(sum % size);
}


  


int WordHash4(Word, size)  

char       Word[];
unsigned   size;





{
  unsigned            len, i, j;
  unsigned long int   val;
  char                suffix[SUFFIXLEN + 1];
  


  if ((len = strlen(Word)) <= PREFIXLEN)
  {
    return(0);
  }
  else
  {
    j = PREFIXLEN;
    for (i = 0; i < SUFFIXLEN; i++)
    {
      if (j < len)
      {
        suffix[i] = Word[j];
        j = j + 2;
      }
      else
      {
        suffix[i] = ' ';
      };
    };
    suffix[i] ='\0';

    return(Hash4(suffix, size));
  };

}



    



unsigned long int Hash5(suffix, size)

char       suffix[];
unsigned   size;


{
  unsigned long int   sum;


  sum = suffix[1] * 13 + suffix[0] * 53 * 73 + suffix[3] * 71 * 79 * 53 
        + suffix[2] * 91 * 113 * 97 * 73;
  return(sum % size);
}


  


int WordHash5(Word, size)  

char       Word[];
unsigned   size;





{
  unsigned            len, i, j;
  unsigned long int   val1, val2;
  char                suffix[SUFFIXLEN + 1];
  char                pretail[PRETAILLEN + 1];




  if ((len = strlen(Word)) <= PREFIXLEN)
  {
    return(0);
  }
  else
  {
    if (len <= (PREFIXLEN + SUFFIXLEN))
    {
      j = PREFIXLEN;
      for (i = 0; i < SUFFIXLEN; i++)
      {
        if (j < len)
        {
          suffix[i] = Word[j ++];
        }
        else
        {
          suffix[i] = ' ';
        };
      };
      suffix[i] ='\0';
      
      val1 = Hash5(suffix, size);
      srand2(val1);
      return((rand2() * 10 * val1) % size);
    }
    else
    {
      j = PREFIXLEN;
      for (i = 0; i < PRETAILLEN; i++)
      {
        pretail[i] = Word[j ++];
      };
      pretail[i] = '\0';
      
      j = len - SUFFIXLEN;
      for (i = 0; i < SUFFIXLEN; i++)
      {
        suffix[i] = Word[j++];
      };
      suffix[i] = '\0';

      val1 = Hash3(pretail, size);
      srand2(val1);
      val1 = rand2() * 10 * val1;

      val2 = Hash1(suffix, size);
      srand2(val2);
      val2 = rand2() * 10 * val2;
      
      return((val1 + val2) % size);
    };
  };

}



   

      

      





      

    

