/*  first record of exexts.h***** */
/* *****************************************************
 *  defines external variables for execution module
 *  (NO allocation)
 * *****************************************************
 */
extern FILE *chkfil;
extern FILE *prmfil;
extern FILE *errfil; 
extern FILE *logfil[logfilmax]; 
extern FILE *trsprobfil;
extern FILE *trsdefsfil;
extern FILE *trsextsfil;
extern FILE *trscodefil;
extern FILE *lrnthmfil;
extern FILE *lrnrowfil;
extern FILE *prgfil;
extern FILE *condiptfil;  
extern char trsprobfil_name[256];
extern char trsprobfil_nopa[256];
extern char trsdefsfil_name[256];
extern char trsdefsfil_nopa[256];
extern char trsextsfil_name[256];
extern char trsextsfil_nopa[256];
extern char trscodefil_name[256];
extern char trscodefil_nopa[256];
extern char prgfil_name[256];
extern char condiptfil_name[256];
extern char logfil_name[256];
extern char errfil_name[256];
extern char lrnthmfil_name[256];
extern char lrnrowfil_name[256];
extern char filnam[256];
extern char auxnam[256]; 
extern char namext[(namemax+1)*5];
extern char prbdir[256];
extern char parstr[256];
extern long logcline[logfilmax];
extern long nlogfil;

/*eject*/
typedef struct {
  char  name[58+1];
  short status;
} CLAUSE_ARRAY;
typedef char PRGNAME_ARRAY[256+1]; 
extern long lpxalcflg;
extern long exalcflg;
extern long tralcflg;
extern long nonusewarnflg;
extern long trsprocessflg;
extern long keepallvarflg;
extern long mktrsprocfilflg;
extern long outputprgflg;
extern long condiptflg;
extern char begcondiptword[128+1];
extern char endcondiptword[128+1];
extern long colmax;
extern long rowmax;
extern long anzmax;
extern long blkmax;
extern long prbmax;
extern long stomax;
extern long laymax;
extern long apmbnd;
extern char lbzver[4+1];
extern long apmflg;
extern long selvr[4];
extern long automt;
extern long satchk;
extern long bstver;
extern long lrnflg;
extern long lrnoutflg;
extern long ilrncyc;
extern long nlrncyc;
extern long ilrnzero;
extern long nlrnzero;
extern long lrnsucc;
extern long nselvr;
extern long iselvr;
extern long scrflg;
extern long accflg;
extern long selpgv;
extern long flgprb;
extern long flgopt;
extern long flgtrm;
extern long flgatf;
extern long flggol;

/*eject*/
extern long c1;
extern long c2;
extern long c3;
extern long c4;
extern long c5;
extern long c6;
extern long c7;
extern long c8;
extern long c9;
extern long pgnum;
extern long npgrec;
extern char *pgrec;
extern char *pgalp;
extern long *xpoint;
extern double *xvalue;
extern char *xcomnd;
extern char *colnam;
extern char *rownam;
extern char *clnam;
extern char *rwnam;
extern long *idxclx;
extern long ncolsx;
extern long asgflg;
extern long solflg;
extern long satble;
extern long xerror;
extern long zeroerr;
extern long warn;
extern long nftl;
extern long fatl;
extern long errval;
extern long execerr[3];
extern long execerrmax[3];
extern long optimr;
extern unsigned long randseed;
extern long *trucsr;
extern long *falcsr;
extern double *rndzv;
extern double *deltaz;
extern long *xcl2lp;
extern long *xlp2cl;
extern long *xrw2lp;
extern long *xlp2rw;
extern long *lpstat;
extern long *rndcl;
extern long *rndcas;
extern long *rndfsb;
extern long *nlurr;
extern long *ciacpr;
extern double *lrrval;
extern double *urrval;
extern long irec;
extern long currec;
extern long antrec;
extern long fstrec;
extern long lstrec;
extern long nfrrec;
extern long usdrec;
extern long nrecs;
extern long *nxtrec;
extern long *prbbeg;
extern long *prbend;
extern long *prbsiz;
extern long lprb;
extern long nprbs;
extern long stoflg;
extern char *storec;
extern char *prbnam;
extern long nblks;
extern long *nbks;
extern long *nders;
extern long *ndrge;
extern long *nerge;
extern long *ndrgep;
extern long *nergep;
extern long *npairs;
extern long nrg;
extern long nrgx;
extern long nnzrg;
extern long nnzrgx;
extern long *lcllim;
extern long *ucllim;
extern long *lrwlim;
extern long *urwlim;
extern long lcllmt;
extern long ucllmt;
extern long lrwlmt;
extern long urwlmt;
extern long nanzs;
extern long *nnzs;
extern long ncols;
extern long *ncls;
extern long nrows;
extern long *nrws;
extern long succss;
extern long *twosat;
extern long *twost;
extern long flgrge;
extern long devdif;
extern long totmem;
extern long *fxcase;
extern long aggidx;
extern long aggdif;
extern long evalsubflg;
extern long ngols;
extern long jxgoal;
extern long ttcost;
extern long prcost;
extern long lbcost;
extern long q1cost;
extern long cost1;
extern long *trucst;
extern long *falcst;
extern long *trcst;   
extern long *flcst;
extern long optimz;
extern long pmvalue;
extern long bstval;
extern long *prmdat;
extern long *prmlim;
extern long *nprms;
extern long psize;
extern long *csourc;
extern long *rsourc;
extern long *csink;
extern long *rsink;
extern long *cnew;
extern long *rnew;
extern long *ccut;
extern long *rcut;
extern long jscan;
extern long jcol;
extern long juser;
extern long jval;
extern long iscan;
extern long jnam;
extern long inam;
extern long istar;
extern long qblock;
extern long maxcut;
extern long bstcut;
extern long onpath;
extern long srcsiz;
extern long nodlim;
extern long flgsrc;
extern long *cdis;
extern long *rdis;
extern long cfar;
extern long distce;
extern long *histdc;
extern long *drange;
extern long *ptdr;
extern long *nzdr;
extern long *pter;
extern long *nzer;
extern long dr;
extern long dr1;
extern long er;
extern long er1;
extern long *rg;
extern long *ptrg;
extern long *nzrg;
extern long *rgx;
extern long *ptrgx;
extern long *nzrgx;
extern long zrgx;
extern long *lcost;
extern long *rgxlst;
extern long *rgxusd;
extern long *auxv1;
extern long *auxv2;
extern long *auxv3;
extern long *aux;
extern long *va;
extern long *vb;
extern long *vc;
extern long *ldr;
extern long *ler;
extern long *ldr1;
extern long *ler1;
extern long rgxcur;
extern long *retsol;
extern double realk;
extern double realtl;
extern double realts;
extern double realtp;
extern double realto;
extern long bdfxvr;
extern long *bdfxbl;
extern long *logrge;
extern long *ablkct;
extern long inselt;
extern long mspeed;
extern long *attblk;
extern long *cl;
extern long *centry;
extern long *clalli;
extern long *clacti;
extern long *clinai;
extern long *cxlfix;
extern long *cxlbnd;
extern long *cxlsol;
extern long *cxlinp;
extern long *cxlbegthm;
extern long *cxlthm;
extern long *cxlpath;
extern long *rw;
extern long *rentry;
extern long *rwallj;
extern long *rwactj;
extern long *rwfixj;
extern long *rwfrej;
extern long *rwinaj;
extern long *rnred;
extern long *rxlact;
extern long *rxleqz;
extern long *rxleq1;
extern long *rxlcu1;
extern long *rxleq2;
extern long *rposj;
extern long *rxlrhs;
extern long *ronej;
extern long *aonej;
extern long *rxlntz;
extern long *rxlinp;
extern long *amc;
extern long *ptamc;
extern long *nzamc;
extern long *amr;
extern long *ptamr;
extern long *nzamr;
extern long *ablkcl;
extern long *ptablc;
extern long *nzablc;
extern long *ablkrw;
extern long *ptablr;
extern long *nzablr;
extern long *amslcl;
extern long *ptamsc;
extern long *nzamsc;
extern long *amslrw;
extern long *ptamsr;
extern long *nzamsr;
extern long *rnared;
extern long *bmslcl;
extern long *ptbmsc;
extern long *nzbmsc;
extern long *bmslrw;
extern long *ptbmsr;
extern long *nzbmsr;
extern long *rnbred;
extern long *ribred;
extern long *rxlbw1;
extern long *rxlbwz;
extern long *bdvalu;
extern long *bdcase;
extern long *bdcons;
extern long *bdsave;
extern long *bdtemp;
extern long *trsvar;
extern long thmlen;
extern long thmlenmax;
extern long nthms;
extern long *thmmat;
extern long *ptthmmat;
extern long *pathcase;
extern long nconcl;
extern long nconfx;
extern long nsavec;
extern long nsavex;
extern long nunitres;
extern long *selcol;
extern long *covtot;
extern long *covmat;
extern long *selcas;
extern long nsatrow;
extern long *nstrow;
extern long nslcol;
extern long nslcas;
extern long curcas;
extern long lowbnd;
extern long *erange;
extern long *gpod;
extern long *gpoe;
extern long *gpodp;
extern long *gpoep;
extern long *cnallp;
extern long *cnalln;
extern long *cnall;
extern long *cnactp;
extern long *cnactn;
extern long *cnact;
extern long *cninap;
extern long *cninan;
extern long *cnina;
extern long *ciactr;
extern long *ciinar;
extern long *cifrer;
extern long *cifixr;
extern long *ciacgl;
extern long *idxgol;
extern long *idxgnm;
extern long *gcoeff;
extern long *primal;
extern long *ciact;
extern long *ciina;
extern long *cifre;
extern long *cifix;
extern long *solut1;
extern long *solut2;
extern long *solut3;
extern long *solut4;
extern long *solut5;
extern long *scale;
extern long *idxcol;
extern long *ciblk;
extern long *dlclop;
extern long *cost;
extern long *cvatf;
extern long ncvatf1;
extern long *inlsol;
extern long *rnallp;
extern long *rnalln;
extern long *rnall;
extern long *rnactp;
extern long *rnactn;
extern long *rnact;
extern long *rninap;
extern long *rninan;
extern long *rnina;
extern long *rnfrep;
extern long *rnfren;
extern long *rnfre;
extern long *rnfixp;
extern long *rnfixn;
extern long *rnfix;
extern long *riactr;
extern long *riinar;
extern long *levelr;
extern long *dual;
extern long *goalxq;
extern long *glocst;
extern long *ghicst;
extern long *goalus;
extern long *goalrq;
extern long *glflg;
extern long *riact;
extern long *riina;
extern long *rhs1;
extern long *rhs2;
extern long *rhs3;
extern long *rhs4;
extern long *rhs5;
extern long *idxrow;
extern long *riblk;
extern long *dlrwop;
extern long *level;
extern long *amatcl;
extern long *ptamac;
extern long *nzamac;
extern long *amatrw;
extern long *ptamar;
extern long *nzamar;
extern long *clpath;
extern long *claugm;
extern long *clstat;
extern long *clcutn;
extern long *cllabn;
extern long *rwpath;
extern long *rwaugm;
extern long *rwstat;
extern long *rwcutn;
extern long *rwlabn;
extern long *height;
extern long *curprm;
extern long *fnlprm;
extern long *tmpprm;
extern long *bstprm;
/*  last record of exexts.h****** */

/* temporary variables */
extern long ncount;
