#define  INITIAL_SEED      17
#define  MULTIPLIER        25173
#define  INCREMENT         13849
#define  MODULUS           32767    /*65536*/
#define  FLOATING_MODULUS  65536.0

static unsigned long seed = INITIAL_SEED; 
 /* SEED is external but private to this file */

unsigned long rand2(void)
 {
    seed = (MULTIPLIER * seed + INCREMENT ) % MODULUS;
    return seed;
  }

/*=================*/
  
void srand2(unsigned long int k)
 {
   seed = k; 
 }  
  

