#include <stdlib.h>
#include <string.h>
                                                             
#include     "create.h"
#include     "HashFnct.h"
 
#define  ORGDIC     "word.dat.org"
#define      BIDX       "bckt.idx"
#define      WORDDAT    "word.dat"



struct   BcktIdxEnt  Bindex[SIZEOFWORDBK];
int                  Bnameidx;
char                 Bname[NUMOFBUCKET][PREFIXLEN + 1];
unsigned             freq;
char                 prefix[PREFIXLEN + 1], Word[MAXWORDLEN + 1], 
                     tmp[PREFIXLEN + 1];









int  GetBcktIdx()

{

  unsigned   i, val;
  



  val = BcktHash(prefix);
  i = 0;
/*printf("hashvalue1 %d\n", val);*/
/*printf("prefix %s\n", wordbk[val].bcktnm);*/
  while ((strcmp(Bindex[val].bcktnm, prefix) != 0) && (i <= MAXBKCONFLICT))
  {
    if (Bindex[val].bcktnm[0] == '\0')
    {
      i = MAXBKCONFLICT;
    };

    val = (val + 1) % SIZEOFWORDBK;
    i++;
  };

  if (i > MAXBKCONFLICT)
  {
    return(-1);
  }
  else
  {
    return(val);
  };
}




main()

{ 
  int                i, k, bcktidx;
  unsigned long int  j, total, loc;
  char               pattern[10];
  boolean            new;
  char               ch;


  FILE  *dict, *bname, *bidx, *wddat;


  total = 0;
  loc = 0;
  Bnameidx = -1;

 printf("open file begin\n");


  if ((dict = fopen(ORGDIC, READ)) == NULL)
  {
    fprintf(stderr, "fail to open the %s \n", ORGDIC);
    exit(0);
  };



  if ((bidx = fopen(BIDX, READ)) == NULL)
  {
    fprintf(stderr, "fail to open the %s \n", BIDX);
    exit(0);
  };

  ReadSucc = fread(Bindex, sizeof(Bindex), 1, bidx);
  if (! ReadSucc)
  {
    fprintf(stderr, "fail to read from %s\n", BIDX);
    exit(0);
  };

  


  if ((wddat = fopen(WORDDAT, WRITE)) == NULL)
  {
    fprintf(stderr, "fail to open the %s \n", WORDDAT);
    exit(0);
  };



printf("open file complete\n");
  for (j = 0; j < NUMOFWORDS; j ++)
  {
   
    fscanf(dict, "%s %s\n", Word, pattern);
    loc = loc + strlen(Word) + strlen(pattern) + 2;

  
    
    strncpy(prefix, Word, PREFIXLEN);
    while ((i = strlen(prefix)) < PREFIXLEN)
    {
      prefix[i] = ' ';
      prefix[i + 1] = '\0';
    };

    new = TRUE;
    for (i = Bnameidx; i >= 0; i--)
    {
      if (strcmp(prefix, Bname[i]) == 0)
      {
        new = FALSE;
        break;
      };
    };

    if (new)
    {
      
      strcpy(Bname[++Bnameidx], prefix);

      printf("sort bckt %s\n", prefix);

      if ((bcktidx = GetBcktIdx()) == -1)
      {
      printf("there is no prefix %s in %s for word %s\n", prefix, BIDX,Word);
           exit(0);
/*printf("WORD:  %s,  PREFIX:  %s, PATTERN:  %s\n", Word, prefix, pattern);*/
      }
      else
      {

        freq = Bindex[bcktidx].freq; 
        i = 1;
        fprintf(wddat, "%s %s\n", Word, pattern);
        total ++;

        while (i < freq)
        {
          fscanf(dict, "%s %s\n", Word,  pattern);
      
          strncpy(tmp, Word, PREFIXLEN);
          while ((k = strlen(tmp)) < PREFIXLEN)
          {
            tmp[k] = ' ';
            tmp[k + 1] = '\0';
          };
          if (strcmp(prefix, tmp) == 0)
          {
            i ++;
            fprintf(wddat, "%s %s\n", Word, pattern);
            total ++;
          };
        };
      };

    };
    fseek(dict, loc, 0);
    if (feof(dict))  break;
  };


     

  printf("there are %ld words\n\n", total);

  
  


  fclose(dict);
  fclose(bidx);
  fclose(wddat);


 }
  

    
    
  
