#include    <sys/time.h>  


#include     <fcntl.h>

#include     "spell_cnst.h"
/*------- 110398 -------------*/
#include     "random.h"
/*---------------------------*/

#include "spellroutines.h"


unsigned     ReadSucc;
char         Twd_Awd, Found_Not;
char         BcktIdx[120], WordIdx[120], WordDat[120];
int          Is_wdfm, Not_wdfm, Errtyp;


/**&&&&&&&&&7/99&&&&&&&&**/
extern struct rplc_word  rplc_dict[];
extern int   rplc_end;
boolean      opened_usr_rplcmnt = FALSE;
/**&&&&&&end7/99&&&&&&&&**/


FILE         *wdbkindex, *wdidx, *wddat;






/*    HashFnct.h  */



int BcktHash(prefix)  

char  prefix[];

{
  unsigned long int   sum;
 
  sum = prefix[0] * 31 + prefix[2] * 83 * 83 + prefix[1] * 72 * 72 *72; 
  return(sum % SIZEOFWORDBK);
}
   


unsigned long int Hash1(suffix, size)

char       suffix[];
unsigned   size;


{
  unsigned long int   sum;


  sum = suffix[0] * 31 + suffix[2] * 83 * 83 + suffix[1] * 72 * 72 * 72 
        + suffix[3] * 95 * 91 * 97 * 73;
  return(sum % size);
}


  


int WordHash1(Word, size)  

char       Word[];
unsigned   size;





{
  unsigned            len, i, j;
  /*  unsigned long int   val; */
  char                suffix[SUFFIXLEN + 1];
  


  if ((len = strlen(Word)) <= PREFIXLEN)
  {
    return(0);
  }
  else
  {
    j = PREFIXLEN;
    for (i = 0; i < SUFFIXLEN; i++)
    {
      if (j < len)
      {
        suffix[i] = Word[j ++];
      }
      else
      {
        suffix[i] = ' ';
      };
    };
    suffix[i] ='\0';

    return(Hash1(suffix, size));
  };
   
}


      

    



unsigned long int Hash2(suffix, size)

char       suffix[];
unsigned   size;


{
  unsigned long int   sum;


  sum = suffix[1] * 11 + suffix[3] * 83 * 73 + suffix[2] * 72 * 79 * 53 
        + suffix[0] * 91 * 87 * 97 * 73;
  return(sum % size);
}


  


int WordHash2(Word, size)  

char       Word[];
unsigned   size;





{
  unsigned            len, i, j;
  unsigned long int   val1, val2;
  char                suffix[SUFFIXLEN + 1];
  char                pretail[PRETAILLEN + 1];




  if ((len = strlen(Word)) <= PREFIXLEN)
  {
    return(0);
  }
  else
  {
    if (len <= (PREFIXLEN + SUFFIXLEN))
    {
      j = PREFIXLEN;
      for (i = 0; i < SUFFIXLEN; i++)
      {
        if (j < len)
        {
          suffix[i] = Word[j ++];
        }
        else
        {
          suffix[i] = ' ';
        };
      };
      suffix[i] ='\0';
      
      val1 = Hash2(suffix, size);
      srand2(val1);
      return((rand2() * 10 * val1) % size);
    }
    else
    {
      j = PREFIXLEN;
      for (i = 0; i < PRETAILLEN; i++)
      {
        pretail[i] = Word[j ++];
      };
      pretail[i] = '\0';
      
      j = len - SUFFIXLEN;
      for (i = 0; i < SUFFIXLEN; i++)
      {
        suffix[i] = Word[j++];
      };
      suffix[i] = '\0';

      val1 = Hash2(pretail, size);
      srand2(val1);
      val1 = rand2() * 10 * val1;

      val2 = Hash2(suffix, size);
      srand2(val2);
      val2 = rand2() * 10 * val2;
      
      return((val1 + val2) % size);
    };
  };

}




unsigned long int Hash3(suffix, size)

char       suffix[];
unsigned   size;


{
  unsigned long int   sum;


  sum = suffix[0] * 41 + suffix[1] * 67 * 83 + suffix[2] * 72 * 59 * 72 
        + suffix[3] * 83 * 91 * 97 * 89;
  return(sum % size);
}


  


int WordHash3(Word, size)  

char       Word[];
unsigned   size;





{
  unsigned            len, i, j;
  char                suffix1[SUFFIXLEN + 1], suffix2[SUFFIXLEN + 1];
  


  if ((len = strlen(Word)) <= PREFIXLEN)
  {
    return(0);
  }
  else
  {
    j = PREFIXLEN;
    for (i = 0; i < SUFFIXLEN; i++)
    {
      if (j < len)
      {
        suffix1[i] = Word[j ++];
        if (j < len)
        {
          suffix2[i] = Word[j ++];
        }
        else
        {
          suffix2[i] = ' ';
        };
      }
      else
      {
        suffix1[i] = ' ';
        suffix2[i] = ' ';
      };
    };
    suffix1[i] = '\0';
    suffix2[i] = '\0';

    return((Hash3(suffix1, size) + Hash3(suffix2, size)) % size);
  };
   
}






unsigned long int Hash4(suffix, size)

char       suffix[];
unsigned   size;


{
  unsigned long int   sum;


  sum = suffix[3] * 31 + suffix[2] * 93 * 83 + suffix[1] * 72 * 83 * 62 
        + suffix[0] * 95 * 93 * 97 * 99;
  return(sum % size);
}


  


int WordHash4(Word, size)  

char       Word[];
unsigned   size;





{
  unsigned            len, i, j;
  char                suffix[SUFFIXLEN + 1];

  if ((len = strlen(Word)) <= PREFIXLEN)
  {
    return(0);
  }
  else
  {
    j = PREFIXLEN;
    for (i = 0; i < SUFFIXLEN; i++)
    {
      if (j < len)
      {
        suffix[i] = Word[j];
        j = j + 2;
      }
      else
      {
        suffix[i] = ' ';
      };
    };
    suffix[i] ='\0';

    return(Hash4(suffix, size));
  };

}



    



unsigned long int Hash5(suffix, size)

char       suffix[];
unsigned   size;


{
  unsigned long int   sum;


  sum = suffix[1] * 13 + suffix[0] * 53 * 73 + suffix[3] * 71 * 79 * 53 
        + suffix[2] * 91 * 113 * 97 * 73;
  return(sum % size);
}


  


int WordHash5(Word, size)  

char       Word[];
unsigned   size;





{
  unsigned            len, i, j;
  unsigned long int   val1, val2;
  char                suffix[SUFFIXLEN + 1];
  char                pretail[PRETAILLEN + 1];




  if ((len = strlen(Word)) <= PREFIXLEN)
  {
    return(0);
  }
  else
  {
    if (len <= (PREFIXLEN + SUFFIXLEN))
    {
      j = PREFIXLEN;
      for (i = 0; i < SUFFIXLEN; i++)
      {
        if (j < len)
        {
          suffix[i] = Word[j ++];
        }
        else
        {
          suffix[i] = ' ';
        };
      };
      suffix[i] ='\0';
      
      val1 = Hash5(suffix, size);
      srand2(val1);
      return((rand2() * 10 * val1) % size);
    }
    else
    {
      j = PREFIXLEN;
      for (i = 0; i < PRETAILLEN; i++)
      {
        pretail[i] = Word[j ++];
      };
      pretail[i] = '\0';
      
      j = len - SUFFIXLEN;
      for (i = 0; i < SUFFIXLEN; i++)
      {
        suffix[i] = Word[j++];
      };
      suffix[i] = '\0';

      val1 = Hash3(pretail, size);
      srand2(val1);
      val1 = rand2() * 10 * val1;

      val2 = Hash1(suffix, size);
      srand2(val2);
      val2 = rand2() * 10 * val2;
      
      return((val1 + val2) % size);
    };
  };

}

 


struct   BcktIdxEnt  Bindex[SIZEOFWORDBK];
struct   WordIdxEnt  Windex[WDIDXSIZE];
char                 prefix[PREFIXLEN + 1];
char                 Wdata[SIZEOFWDDAT];






int  GetBcktIdx()


{

  unsigned   i, val;
  



  val = BcktHash(prefix);
  i = 0;
  while ((strcmp(Bindex[val].bcktnm, prefix) != 0) && (i <= MAXBKCONFLICT))
  {
    if (Bindex[val].bcktnm[0] == '\0')
    {
      i = MAXBKCONFLICT;
    };

    val = (val + 1) % SIZEOFWORDBK;
    i++;
  };

  if (i > MAXBKCONFLICT)
  {
    return(-1);
  }
  else
  {
    return(val);
  };
}







unsigned  HashVal(Word, fnct, size)

char      Word[];
char      fnct;
unsigned  size;


{
  unsigned  val; 
 
  
  switch(fnct)
  {
    case '1':  val = WordHash1(Word, size);
               break;
    case '2':  val = WordHash2(Word, size);
               break;
    case '3':  val = WordHash3(Word, size);
               break;
    case '4':  val = WordHash4(Word, size);
               break;
    case '5':  val = WordHash5(Word, size);
               break;

  };


  return(val);
 
}

                 




/*  DctAcc.h  */




void  read_dict()

{
  char msg[100];


  printf("\n\nReading system files, user dictionary, and user history file ...\n\n");
 
  if ((wddat = fopen(WordDat, READ)) == NULL) {
    sprintf(msg, "fail to open the %s.", WordDat);
    running_error(msg);
  }

  ReadSucc = fread(Wdata, sizeof(Wdata), 1, wddat);
  if (! ReadSucc) {
    sprintf(msg, "fail to read from %s.", WordDat);
    running_error(msg);
  }


  if ((wdbkindex = fopen(BcktIdx, READ)) == NULL) {
    sprintf(msg, "fail to open the %s.", BcktIdx);
    running_error(msg);
  }

  ReadSucc = fread(Bindex, sizeof(Bindex), 1, wdbkindex);
  if (! ReadSucc) {
    sprintf(msg, "fail to read from %s.", BcktIdx);
    running_error(msg);
  }


  if ((wdidx = fopen(WordIdx, READ)) == NULL) {
    sprintf(msg, "fail to open the %s.", WordIdx);
    running_error(msg);
  }

  ReadSucc = fread(Windex, sizeof(Windex), 1, wdidx);
  if (! ReadSucc) {
    sprintf(msg, "fail to read from %s.", WordIdx);
    running_error(msg);
  }

  fclose(wddat);
  fclose(wdbkindex);
  fclose(wdidx);
}


/*-----------------------------------------------------------------------

  apstrph_transf  --  transfer possible apostraphe classification into 
                      corresponding code

    input  -- pt1:  original patterns
    output -- pt2:  transfered patterns

------------------------------------------------------------------------*/
void apstrph_transf(pt1, pt2)
char *pt1, *pt2;
{
  int  len, i, j;
  char pt[4], ch1, ch2;

  len = strlen(pt1);
  if (len < 3) {
    strcpy(pt2, pt1);
    return;
  }

  j = 0;
  for (i = 0; i < len; i++) {
    if (i < (len-2)) {
      ch1 = pt1[i];
      if ((ch1 == 's') || (ch1 == 'S') 
                       || (ch1 == 't') ) {
        ch2 = pt1[i+1];
        if (ch2 == '\'') {
          pt[0] = ch1;
          pt[1] = ch2;
          pt[2] = pt1[i+2];
          pt[3] = '\0';
          if (strcmp(pt,"s'h") == 0) { pt2[j++] = '0'; i = i+2; continue; }
          if (strcmp(pt,"s'H") == 0) { pt2[j++] = '1'; i = i+2; continue; }
          if (strcmp(pt,"s'b") == 0) { pt2[j++] = '2'; i = i+2; continue; }
          if (strcmp(pt,"s'x") == 0) { pt2[j++] = '3'; i = i+2; continue; }
          if (strcmp(pt,"s'X") == 0) { pt2[j++] = '4'; i = i+2; continue; }
          if (strcmp(pt,"S'h") == 0) { pt2[j++] = '5'; i = i+2; continue; }
          if (strcmp(pt,"S'H") == 0) { pt2[j++] = '6'; i = i+2; continue; }
          if (strcmp(pt,"S'b") == 0) { pt2[j++] = '7'; i = i+2; continue; }
          if (strcmp(pt,"S'x") == 0) { pt2[j++] = '8'; i = i+2; continue; }
          if (strcmp(pt,"S'X") == 0) { pt2[j++] = '9'; i = i+2; continue; }
          if (strcmp(pt,"t'S") == 0) { pt2[j++] = '9'; i = i+2; continue; }
           
        }
      }
    }
    pt2[j++] = pt1[i];
  }
  pt2[j] = '\0';
}

        
boolean  Find_Word(Word, pattern)
char Word[], pattern[];
{ 
  int                i, bcktidx, j, maxc;
  unsigned long int  wordidx, base, idx;
  char               fnt;
  unsigned           freq, size, len, hval;
  boolean            found;
  char               Word1[MAXWORDLEN + 1], ptrn[MAXPTRNS+1];


  found = FALSE;
  ptrn[0] = '\0';
  strncpy(prefix, Word, PREFIXLEN);
  prefix[PREFIXLEN] = '\0';
  while ((i = strlen(prefix)) < PREFIXLEN)
  {
    prefix[i] = ' ';
    prefix[i + 1] = '\0';
  };

  if ((bcktidx = GetBcktIdx()) == -1)
  {
/*   printf("word '%s' is not in the dictionary\n", Word);
 printf("there is no prefix %s in %s for word %s\n", prefix, BcktIdx,Word);*/
  }
  else
  {
    freq = Bindex[bcktidx].freq;
    base = Bindex[bcktidx].bkloc;
    size = Bindex[bcktidx].bksize;
    fnt = Bindex[bcktidx].fnct;
    maxc = Bindex[bcktidx].maxcnft;
   

    hval = HashVal(Word, fnt, size);
    wordidx = base + hval;
    len = strlen(Word);
    
   
    for (i = 0; i <= maxc; i ++)
    {
      if (len != Windex[wordidx].length)
      {
        hval = (hval + 1) % size;
        wordidx = base + hval;

      }
      else
      {
        idx = Windex[wordidx].wdloc;
        j = 0;

        while (Wdata[idx] != ' ')
        {
          Word1[j++] = Wdata[idx++];
        };
        Word1[j] = '\0';

        if (strcmp(Word, Word1) == 0)
        {
          idx ++;
          j = 0;
          while (Wdata[idx] != '\n')
          {
            ptrn[j++] = Wdata[idx++];
          };
          ptrn[j] = '\0';

          found = TRUE;
          break;
        }
        else
        {
          hval = (hval + 1) % size;
          wordidx = base + hval;
        };

      };
    };
  };
  if (found) apstrph_transf(ptrn, pattern);
  return(found);
    

}
  
/*************************************************************************/
/*************************************************************************/


extern int                   usrdctdat_ptr, dcmdct_ptr, errhstry_ptr, 
                             errhstry_head, usrdct_ptr, onewddat_ptr, maxfrq,
                             dcmdct_head[MAXWORDLEN + 1], 
                             err_hstry[RCNTERR_MAX + 1],
                             usrdct_head[];
extern float                 alpha;
extern char                  text_name[], data_path[], wdfm_prg[], act_prg[];
extern boolean               abccflg, classify, accept_unknown,text_changed;
extern struct  OneWord       onewddat[];
extern struct  UserWd        usrdctdat[];
extern struct  DictIndex     dcm_dct[], usr_dct[];
extern boolean               has_nono;

/**&&&&&&&&&7/99&&&&&&&&**/
boolean               has_rplc;
/**&&&&&&end7/99&&&&&&&&**/


typedef  struct  DictIndex     words_idx;




char   wds_usr[120], hst_usr[120], wds_bak[120], wds_idx[120], 
       err_usr[120], text_ext[20], old_wdsusr[120], old_hstusr[120], 
       nono_usr[120], old_nonousr[120],
 /**&&&&&&&&&7/99&&&&&&&&**/
       usr_rplcmnt[120];
 /**&&&&&&end7/99&&&&&&&&**/

/****** added on 04/06/97 ******/

int    size_altlist;         /* number of alternatives provided */

/****** 04/06/97 ******/


boolean   empty_wdusr = FALSE;



FILE   *usrerr, *params;







/*************************************************************************/
/* Function to copy the information of user dictionary(usr_dct,usrdctdat,*/
/* etc.) to document dictionary(dcm_dct, onewddat, etc.)                 */
/*************************************************************************/

void  copy_usrdct()

{
  int    i;

  onewddat_ptr = usrdctdat_ptr;
  dcmdct_ptr = usrdct_ptr;
  
  for (i = 0; i <= MAXWORDLEN; i++)
  {
    dcmdct_head[i] = usrdct_head[i];
  };
  
  for (i = 0; i < dcmdct_ptr; i++)
  {
    strcpy(dcm_dct[i].word, usr_dct[i].word);
    dcm_dct[i].count = usr_dct[i].count;
    dcm_dct[i].code = usr_dct[i].code;
    dcm_dct[i].red = usr_dct[i].red;
    dcm_dct[i].left = usr_dct[i].left;
    dcm_dct[i].right = usr_dct[i].right;
  };

  for (i = 0; i < usrdctdat_ptr; i++)
  {
    strcpy(onewddat[i].word, usrdctdat[i].word);
    strcpy(onewddat[i].root, usrdctdat[i].root);
    strcpy(onewddat[i].suffix, usrdctdat[i].suffix);
    strcpy(onewddat[i].pttrn, usrdctdat[i].pttrns);
    onewddat[i].is_wf = usrdctdat[i].is_wf;
    onewddat[i].not_wf = usrdctdat[i].not_wf;
    onewddat[i].errtype = 0;
    onewddat[i].ptr1 = -1;
    onewddat[i].ptr2 = -1;
    onewddat[i].ptr3 = -1;
  };
}



/***************************************************************************/
/*  Function to figure out params in params.dat                            */
/***************************************************************************/

boolean figure_out(lhs, rhs, record)

char  *lhs, *rhs, *record;

{
  char    str[120], ch;
  int     i, l = 0, r = 0;
  boolean right = FALSE, done = FALSE;

 
  if (feof(params))
  {
    return(FALSE);
  };

  fgets(str, 120, params);
  while ((str[0] == '*') && (str[1] == '*') && (str[2] == '*'))
  {
    if (feof(params))
    {
      return(FALSE);
    };

    fgets(str, 120, params);
  };  
  
  strcpy(record, str);
  for (i = 0; i < 120; i++)
  {
    ch = str[i];

    switch (ch)
    {
      case ' ':
                break;
  
      case '=':
                right = TRUE;
                break;

      case '\n':
                 done = TRUE;
                 break;

      default:
               if (right)
               {
                 rhs[r++] = ch;
               }
               else
               {
                 lhs[l++] = ch;
               };
    };

    if (done)
    {
      break;
    };
  };

  lhs[l] = '\0';
  rhs[r] = '\0';

  return(TRUE);

}

  

/*************************************************************************/
/*  Function to open and read info from params.dat file                  */
/*************************************************************************/

void  read_params(display)
boolean display;
{
  char   lhs[120], rhs[120], record[120], ch, msg[100];
  

/****** changed rhs from 3 to 1 on 1/3/05 ******/

  size_altlist = 1;

/****** changed rhs from 3 to 1 on 1/3/05  ******/

  if ((params = fopen("params.dat", READ)) == NULL) {
    sprintf(msg, "failed to open file params.dat.");
    running_error(msg);
  }

  abccflg = FALSE;

  while (figure_out(lhs, rhs, record))
  {
    if (strcmp(lhs, "displayallfilesduringlaempel(forinternaluseonly)")
      == 0)
    {
      abccflg = TRUE;
      continue;
    };

    if (strcmp(lhs, "directoryofLaempel/Data") == 0)
    {
      strcpy(data_path, rhs);
      continue;
    };

    if (strcmp(lhs, "userhistoryfile") == 0)
    {
      strcpy(hst_usr, rhs);
      continue;
    };

    if (strcmp(lhs, "userdictionary") == 0)
    {
      strcpy(wds_usr, rhs);
      continue;
    };

    if (strcmp(lhs, "userdictionarybackup") == 0)
    {
      strcpy(wds_bak, rhs);
      continue;
    };

    if (strcmp(lhs, "nameoferrorsummaryfile") == 0)
    {
      strcpy(err_usr, rhs);
      continue;
    };
/*
    if (strcmp(lhs, "extensionforcorrectedtextfile") == 0)
    {
      strcpy(text_ext, rhs);
      continue;
    };

    if (strcmp(lhs, "userwillclassifywordsifneeded(yes,no)")
      == 0)
    {
      if (strcmp(rhs, "yes") == 0)
      {
        classify = TRUE;
      }
      else
      {
        classify = FALSE;
      };

      continue;
    };
*/

    if (strcmp(lhs, "fileofwordsexcludedbyuser") == 0)
    {
      strcpy(nono_usr, rhs);
      continue;
    };

   /**&&&&&&&&&7/99&&&&&&&&**/
    if (strcmp(lhs, "usersuggestedreplacements") == 0)
    {
      strcpy(usr_rplcmnt, rhs);
      continue;
    };

   /**&&&&&&end7/99&&&&&&&&**/


/****** added on 04/06/97  ******/

    if (strcmp(lhs, "maxnumberofalternativewords(1,2,3)") == 0) 
    {
      size_altlist = atoi(rhs);
      if ((size_altlist < 1) || (size_altlist > 3)) size_altlist = 3;
      continue;
    }
/****** 04/06/97  ******/

    if (strcmp(lhs, "acceptallunknownwordsascorrect(yes,no)") == 0)
    {
      if (strcmp(rhs, "yes") == 0)
      {
        accept_unknown = TRUE;
      }
      else
      {
        accept_unknown = FALSE;
      };

      continue;
    };

    if (strcmp(lhs,"findsyntacticalinterpretations(yes,no)") == 0)
      continue;

    if (strcmp(lhs,"interactiveorbatchsyntaxchecking(int,bat)") == 0)
      continue;

    if (strcmp(lhs,"userphrasepattern") == 0)
      continue;

    if (strcmp(lhs,"userphrasepatternbackup") == 0)
      continue;

/**%%%%%%%%8/99%%%%%%%%%**/
  
  /***parameters for semantic checking***/
  
   if( (strcmp(lhs,"directoryofWorkarea") == 0) ||
       (strcmp(lhs,"historyreferencefile") == 0) ||
       (strcmp(lhs,"separationsfile") == 0) ||
       (strcmp(lhs,"directoryoflsquare.sepprogram") == 0) ||
       (strcmp(lhs,"directoryoflsquare.votprogram") == 0) ||
       (strcmp(lhs,"directoryofLsquare/Data") == 0) /**||
       (strcmp(lhs,"directoryofLeibniztranslatprogram") == 0) ||
       (strcmp(lhs,"directoryofLeibnizgenerateprogram") == 0)***/  ) 
    
      continue;

  /**%%%%%%end8/99%%%%%%%%**/

  /**%%%default_text_name%%%%%%%**/
  
  if (strcmp(lhs, "filenamestorage") == 0)
    {
      strcpy(filename_storage, rhs);
      continue;
    };
  
  /**%%%end_default_text_name%%%**/


    if (strcmp(lhs, "ENDATA") == 0)
    {
      break;
    };

    printf("\nRecord in file params.dat cannot be interpreted:\n\n");
    printf("    %s\n\n", record);
    printf("Please check the params.dat file and run Laempel again.\n\n");

    printf("Press return key to quit Laempel\n");
    ch = getchar();
    exit(0);
  };

  classify = FALSE;

  strcpy(BcktIdx, data_path);
  strcat(BcktIdx, "/bckt.idx");
  strcpy(WordIdx, data_path);
  strcat(WordIdx, "/word.idx");
  strcpy(WordDat, data_path);
  strcat(WordDat, "/word.dat");
  strcpy(wdfm_prg, data_path);
  strcat(wdfm_prg, "/onewd_wdfm.prg");
  strcpy(act_prg, data_path);
  strcat(act_prg, "/onewd_act.prg");

  if (display) {
    printf("\nParameters used (in file params.dat):\n");
    printf("directory of Laempel/Data       = %s\n", data_path);
    printf("user dictionary                 = %s\n", wds_usr);
    printf("user dictionary backup          = %s\n", wds_bak);
  /**&&&&&&&&&7/99&&&&&&&&**/
    printf("user suggested replacements     = %s\n", usr_rplcmnt);
  /**&&&&&&end7/99&&&&&&&&**/
    printf("words excluded by user          = %s\n", nono_usr);
    printf("user history file               = %s\n", hst_usr);

/****** added on 04/06/97 ******/

    printf("max number of alternative words = %d\n", size_altlist);

/****** 04/06/97 ******/

/*    printf("error summary file      = %s\n", err_usr);
    printf("extension for corrected text file = %s\n", text_ext);*/
    if (accept_unknown) {
      printf("accept all unknown words as correct ('yes' or 'no') = yes\n");
    }
    else {
      printf("accept all unknown words as correct ('yes' or 'no') = no\n");
    }

    if (classify) {
      printf("user will classify words if needed ('yes' or 'no') = yes\n");
    }
/*    else
    {
      printf("user will classify words if needed ('yes' or 'no') = no\n");
    } */
  }
/*
  if (accept_unknown)
  {
    printf("\n!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!\n");
    printf("!                                                       !\n");
    printf("!                        CAUTION                        !\n");
    printf("!                                                       !\n");
    printf("!  All unknown words will be accepted as correct. User  !\n");
    printf("!  must change params.dat file to remove this option.   !\n");
    printf("!                                                       !\n");
    printf("!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!\n");
  };
*/
  fclose(params);
}


void seperate(str, words)
char  *str, words[MAXPTRNS+7][MAXWORDLEN+1];
{
  int  j, l, k, len;
  char ch;

  k = 0;
  l = 0;
  len = strlen(str);

  for (j = 0; j < len; j++)
  {
    ch = str[j];

    if ((ch != ',') && (ch != '\n'))
    {
      words[k][l++] = ch;
    }
    else
    {
      words[k++][l] = '\0';
      l = 0;
    }
  }
}
    

/*************************************************************************/
/*  Function to open user dictionary and history files                   */
/*************************************************************************/
void  read_usrfiles()
{
  /*  unsigned     ReadSucc; */
  int          i, count, num, k, j, l;
  char         str[120], words[MAXPTRNS+7][MAXWORDLEN+1], wd[MAXWORDLEN+1];
  FILE         *usrwd, *usrhst, *wdbak, *nono;
  
  /**&&&&&&&&&7/99&&&&&&&&**/
  FILE         *rplc;
  /**&&&&&&end7/99&&&&&&&&**/

open_usrhst:

  if (strcmp(hst_usr, old_hstusr) == 0) goto open_usrwd;
  if ((usrhst = fopen(hst_usr, READ)) == NULL)
  {
    printf("\nCannot find file = %s\n", hst_usr);
    printf("Press return to confirm creation of new file, or type another file name.\n");
    printf("\nCONFIRM >> ");

    gets(str);
    if (strcmp(str, "") != 0)
    {
      strcpy(hst_usr, str);
      goto open_usrhst;
    };
    
    alpha = 0.0;
  }
  else
  {
    fscanf(usrhst, "%f,", &alpha);
    fscanf(usrhst, "%d,%d,", &errhstry_head, &errhstry_ptr);
    for (i = 0; i < RCNTERR_MAX; i++)
    {
      fscanf(usrhst, "%d,", &err_hstry[i]);
    };
    fscanf(usrhst, "%d\n", &err_hstry[i]);
    
    error_count();
    
    fclose(usrhst);
  };
  strcpy(old_hstusr, hst_usr);

open_usrwd:

  if (strcmp(wds_usr, old_wdsusr) == 0) goto open_nono;
  empty_wdusr = FALSE;

  if ((usrwd = fopen(wds_usr, READ)) == NULL)
  {
    printf("\nCannot find file = %s\n", wds_usr);
    printf("Press return to confirm creation of new file, or type another file name.\n");
    printf("\nCONFIRM >> ");
    
    gets(str);
    if (strcmp(str, "") != 0)
    {
      strcpy(wds_usr, str);
      goto open_usrwd;
    };
    
    /*if ((usrwd = fopen(wds_usr, WRITE)) == NULL) 
    {
      printf("fail to open %s\n", wds_usr);
      exit(0);
    };*/
    empty_wdusr = TRUE;
    dctn_init(usr_dct, usrdct_head, &usrdct_ptr, &usrdctdat_ptr);
    dctn_init(dcm_dct, dcmdct_head, &dcmdct_ptr, &onewddat_ptr);

  }
  else
  {
    dctn_init(usr_dct, usrdct_head, &usrdct_ptr, &usrdctdat_ptr);
    dctn_init(dcm_dct, dcmdct_head, &dcmdct_ptr, &onewddat_ptr);

    fgets(str, 120, usrwd);
    if (version1_version2(str, &usrdctdat_ptr)) {
      i = 0;
      fgets(str, 120, usrwd);
      while (!feof(usrwd)) {
        seperate(str, words);
        if (strcmp(words[0], "") == 0) {
          fgets(str, 120, usrwd);
          continue;
        }
        strcpy(usrdctdat[i].word, words[0]);
        count = atoi(words[3]);
        strcpy(usrdctdat[i].root, words[1]);
        strcpy(usrdctdat[i].suffix, words[2]);
        strcpy(usrdctdat[i].pttrns, words[4]);
        num = strlen(usrdctdat[i].pttrns);
        k = 5;
        for (j = 0;  j < num; j++) {
          usrdctdat[i].ptrn_likelihood[j] = atoi(words[k++]);
        }
 /*       usrdctdat[i].is_wf = atoi(words[k++]);
        usrdctdat[i].not_wf = atoi(words[k]);*/

        if (dcmdct_insert1(usrdctdat[i].word, 
                           i,
                           count,
                           usr_dct,
                           usrdct_head,
                           &usrdct_ptr) >= 0) {/* word is found in dict */
          fgets(str, 120, usrwd);
          continue;
        }
        i++;
        fgets(str, 120, usrwd);
      } /* end of while */
      usrdctdat_ptr = i;
    }
    else {
      l = 0;
      fgets(str, 120, usrwd);
      while (!feof(usrwd)) {
        seperate(str, words);
        if (strcmp(words[0], "") == 0) {
          fgets(str, 120, usrwd);
          continue;
        }
        if (words[4][0] == 'U') {
          strcpy(usrdctdat[l].word, words[0]);
          count = 0;
          strcpy(usrdctdat[l].root, words[1]);
          strcpy(usrdctdat[l].suffix, words[2]);
          strcpy(usrdctdat[l].pttrns, words[4]);
      
          num = strlen(usrdctdat[l].pttrns);
          k = 5;
          for (j = 0;  j < num; j++) {
            usrdctdat[l].ptrn_likelihood[j] = atoi(words[k++]);
          }

        /*  usrdctdat[l].is_wf = atoi(words[k++]);
          usrdctdat[l].not_wf = atoi(words[k]);*/

          if (dcmdct_insert1(usrdctdat[l].word, 
                             l,
                             count,
                             usr_dct,
                             usrdct_head,
                             &usrdct_ptr)>= 0) {/* word is found in dict */
            fgets(str, 120, usrwd);
            continue;
          }
          l++;
        }
      } /* end of while */

      usrdctdat_ptr = l;
    }
               
    
    copy_usrdct();

    fclose(usrwd);

  };
  strcpy(old_wdsusr, wds_usr);

open_nono:

 /* if (strcmp(nono_usr, old_nonousr) == 0) goto open_wdbak;*/
  if ((nono = fopen(nono_usr, READ)) == NULL)
  {
    printf("\nCannot find file = %s\n", nono_usr);
    printf("Press return to confirm creation of new file, or type another file name.\n");
    printf("\nCONFIRM >> ");
    
    gets(str);
    if (strcmp(str, "") != 0)
    {
      strcpy(nono_usr, str);
      goto open_nono;
    };

    nono = fopen(nono_usr, WRITE);
    fclose(nono);
    
    has_nono = FALSE;
  }
  else
  {
    has_nono = FALSE;
    while (!feof(nono)) {
      wd[0] = '\0';
      fscanf(nono, "%s", wd);
      if (strcmp(wd, "") != 0) {
        has_nono = TRUE;
        break;
      }
    }

    if (has_nono) {

      nono_init();
      fseek(nono, 0, 0);

      while (!feof(nono)) {
        wd[0] = '\0';
        fscanf(nono, "%s", wd);
        if (strcmp(wd, "") != 0) { 
          nono_insert(wd);
        }
      } /* end of while */
    }

    fclose(nono);

  }
  strcpy(old_nonousr, nono_usr);

/**&&&&&&&&&7/99&&&&&&&&**/

open_usr_rplcmnt:
  
   if( opened_usr_rplcmnt ) goto  open_wdbak;
   
  if ((rplc = fopen(usr_rplcmnt, READ)) == NULL)
  {
    printf("\nCannot find file = %s\n", usr_rplcmnt);
    printf("Press return to confirm creation of new file, or type another file name.\n");
    printf("\nCONFIRM >> ");
    
    gets(str);
    if (strcmp(str, "") != 0)
    {
      strcpy(usr_rplcmnt, str);
      goto open_usr_rplcmnt;
    };

    rplc = fopen(usr_rplcmnt, WRITE);
    fclose(rplc);
    
    has_rplc = FALSE;
    opened_usr_rplcmnt = TRUE;
  }
  else
  {
    has_rplc = FALSE;
    while (!feof(rplc)) {
      wd[0] = '\0';
      fscanf(rplc, "%s", wd);
      if (strcmp(wd, "") != 0) {
        has_rplc = TRUE;
        break;
      }
    }

    if (has_rplc) {  char  wd2[MAXWORDLEN+1];

      
      fseek(rplc, 0, 0);

      while (!feof(rplc)) {
        wd[0] = '\0';
        fscanf(rplc, "%s", wd);
        fscanf(rplc, "%s", wd2);
        if (strcmp(wd, "") != 0) { 
        rplc_insert(wd, wd2);
        }
      } /* end of while */
    }

    fclose(rplc);
    opened_usr_rplcmnt = TRUE;

  }


/**&&&&&&end7/99&&&&&&&&**/


open_wdbak:

  if ((wdbak = fopen(wds_bak, WRITE)) == NULL)
  {
    printf("\nCannot find file = %s\n", wds_bak);
    printf("Press return to confirm creation of new file, or type another file name.\n");
    printf("\nCONFIRM >> ");
    
    gets(str);
    if (strcmp(str, "") != 0)
    {
      strcpy(wds_bak, str);
      goto open_wdbak;
    };
  }
  else
  {
    fclose(wdbak);
  };


  /*if (abccflg)
  {
    info_print();
  };*/

}


/*************************************************************************/
/*  Function to close user dictionary and history files                  */
/*************************************************************************/
void  write_usrfiles()
{
  unsigned   i;
  int        idx, wdbak_ptr, num, j, count;
  boolean    scaled = FALSE;
  char       str[120], msg[100];
  FILE       *usrwd, *usrhst, *wdbak;
  
  /**&&&&&&&&&7/99&&&&&&&&**/
   FILE      *rplc;
  /**&&&&&&end7/99&&&&&&&&**/
  

  if (has_nono) clean_nono();

  if (! empty_wdusr)
  {
    if ((usrwd = fopen(wds_usr, READWRITE)) == NULL) {
      sprintf(msg, "fail to open %s.", wds_usr);
      running_error(msg);
    }

    if ((wdbak = fopen(wds_bak, WRITE)) == NULL) {
      sprintf(msg, "fail to open %s.", wds_bak);
      running_error(msg);
    }
    fseek(usrwd, 0, 0);
    fseek(wdbak, 0, 0);

    fgets(str, 120, usrwd);
    version1_version2(str, &wdbak_ptr);
    fprintf(wdbak, "%s", str);
    for (i = 0; i < wdbak_ptr; i++)
    {
      fgets(str, 120, usrwd);
      fprintf(wdbak, "%s", str);
    };
    fclose(wdbak);
    fclose(usrwd);
    if ((usrwd = fopen(wds_usr, WRITE)) == NULL) {
      sprintf(msg, "fail to open %s.", wds_usr);
      running_error(msg);
    } 
  }
  else
  {
    if ((usrwd = fopen(wds_usr, WRITE)) == NULL) {
      sprintf(msg, "fail to open %s.", wds_usr);
      running_error(msg);
    }
    empty_wdusr = FALSE;
  };

  fseek(usrwd, 0, 0);
/*  fseek(wdidx, 0, 0);*/
  
  scaled = (maxfrq >= 1000);
  
/*--------- 042797 ----------
  fprintf(usrwd, "%s Number of Words = %d\n", VERSION21, usrdctdat_ptr);
  ---------------------------*/

/*--------- 110398 ----------* 
  fprintf(usrwd, "%s Number of Words = %d\n", VERSION22, usrdctdat_ptr);
 *---------------------------*/

/*-----------ver3.0------------
  fprintf(usrwd, "%s Number of Words = %d\n", VERSION30, usrdctdat_ptr);
 *---------end-ver3.0----------*/

/*-----------ver7.0------------*/
  fprintf(usrwd, "%s Number of Words = %d\n", VERSION70, usrdctdat_ptr);
/*---------end-ver7.0----------*/

  for (i = 0; i < usrdctdat_ptr; i++)
  {
    fprintf(usrwd, "%s,", usrdctdat[i].word);

    if ((idx = dcmdct_search1(usrdctdat[i].word, usr_dct, usrdct_head)) == -1)
    {
      sprintf(msg, "word %s is not in the user dictionary.", usrdctdat[i].word);
      running_error(msg);
    };

    count = usr_dct[idx].count;

    if (scaled)
    {
      count = scaled_freq(count);
    };

    count--;
    if (count < -1000) count = -1000;

    usr_dct[idx].count = count;

    fprintf(usrwd, "%s,", usrdctdat[i].root);

    fprintf(usrwd, "%s,", usrdctdat[i].suffix);

    fprintf(usrwd, "%d,", usr_dct[idx].count);

    fprintf(usrwd, "%s,", usrdctdat[i].pttrns);
 
    num = strlen(usrdctdat[i].pttrns);
    for (j = 0; j < (num-1); j++) 
      fprintf(usrwd, "%d,", usrdctdat[i].ptrn_likelihood[j]);

    fprintf(usrwd, "%d\n", usrdctdat[i].ptrn_likelihood[j]);

  /*  fprintf(usrwd, "%d,", usrdctdat[i].is_wf);

    fprintf(usrwd, "%d\n", usrdctdat[i].not_wf);*/


  };

  fclose(usrwd);


  if ((usrhst = fopen(hst_usr, WRITE)) == NULL) {
    sprintf(msg, "fail to open %s.", hst_usr);
    running_error(msg);
  }

  fprintf(usrhst, "%f,", alpha);
  fprintf(usrhst, "%d,%d,", errhstry_head, errhstry_ptr);
  
  for (i = 0; i < RCNTERR_MAX; i++)
  {
    fprintf(usrhst, "%d,", err_hstry[i]);
  };
  fprintf(usrhst, "%d\n", err_hstry[i]);

  fclose(usrhst);


     /**&&&&&&&&&7/99&&&&&&&&**/
     
    if( rplc_end == 0 )  return;
    
     if ((rplc = fopen(usr_rplcmnt,"w")) == NULL)
         {
           sprintf(msg, "fail to open %s.", usr_rplcmnt);
           running_error(msg);
         }
     
     
         
     for(i=0; i<rplc_end; i++)
      { boolean fileit;
        fileit=TRUE;
        strcpy(str,rplc_dict[i].word2);
        for(j=0; j<strlen(str); j++) 
         if(str[j] == ' ' ) fileit=FALSE;
         if( strcmp(rplc_dict[i].word,rplc_dict[i].word2) == 0 ) 
             fileit=FALSE;
        if( fileit )
         fprintf(rplc,"%s     %s\n",rplc_dict[i].word,rplc_dict[i].word2);
      }
     
     fclose(rplc);
     
     /**&&&&&&end7/99&&&&&&&&**/


}



     
/************************************************************************/
/*  Function to write corrected text file                               */
/************************************************************************/
void  write_text()
{
  char     text_bak[124], ch, cmd[130];
  int      i, code;

  extern int  innertxtout_ptr, innertxtout[];
  
  FILE    *text;

  if (!text_changed) return;

  strcpy(text_bak, text_name);
  strcat(text_bak, ".bak");
  sprintf(cmd, "mv %s %s\n", text_name, text_bak);
  system(cmd);

  if ((text = fopen(text_name, WRITE)) == NULL) {
    char msg[100];

    sprintf(msg, "fail to open %s.", text_name);
    running_error(msg);
  }

  for (i = 0; i < innertxtout_ptr; i++)
  {
    code = innertxtout[i];
    if (code < 0)
    {
      ch = - code;
      fputc(ch, text);
    }
    else
    {
      fputs(usrdctdat[code].word, text);
    };
  };

  fclose(text);
}



void  write_innertext()
{
  char     newname[126], cmd[130];
  int      i;

  extern int  innertxtout_ptr, innertxtout[];
 
  FILE    *innertext;

/*
  strcpy(newname, text_name);
  strcat(newname, ".stc");

  if ((innertext = fopen(newname, READ)) != NULL) {
    fclose(innertext);
    sprintf(cmd, "rm %s\n", newname);
    system(cmd);
  }
*/

  strcpy(newname, text_name);
  strcat(newname, ".stx");

  sprintf(cmd, "rm -f %s\n", newname);
  system(cmd);

  if ((innertext = fopen(newname, WRITE)) == NULL) {
    char msg[100];

    sprintf(msg, "fail to open %s.", newname);
    running_error(msg);
  }

  fprintf(innertext, "Number of Tokens = %d\n", innertxtout_ptr);
  for (i = 0; i < innertxtout_ptr; i++)
  {
    fprintf(innertext, "%d ", innertxtout[i]);
  };

  fclose(innertext);
}


/*---------------------------------------------------------------------
  
  version1_version2  --  check if the user dictionary is matched with the 
                       current version, and return the number of words in
                       the user dictionary.

    input  -- title: the first line in the user dictionary
    output -- num: the number of words in user dictionary

  function returns TRUE if the current version is matched, FALSE otherwise

-----------------------------------------------------------------------*/
boolean version1_version2(title, num)
char *title;
int  *num;
{
  char  version[120], number[120], ch;
  int   len, i, j = 0, k = 0;

  len = strlen(title);
  if (title[0] == '<') {
    for (i = 0; i < len; i++) {
      ch = title[i];
      version[j++] = ch;
      if (ch == '>') break;
    }
  }
  version[j] = '\0';
  for (i = j ; i < len; i++) 
    if (title[i] == '=') break;
  i++;
  while (i < len) number[k++] = title[i++];
  number[k] = '\0';
  *num = atoi(number);
  if (strcmp(version, VERSION11) == 0) return TRUE;
  if (strcmp(version, VERSION20) == 0) return TRUE;

/*--------- 042797 ----------*/
  if (strcmp(version, VERSION21) == 0) return TRUE;
/*---------------------------*/

/*--------- 110398 ----------*/
  if (strcmp(version, VERSION22) == 0) return TRUE;
/*---------------------------*/

/*-----------ver3.0------------*/
if (strcmp(version, VERSION30) == 0) return TRUE;
/*---------end-ver3.0----------*/

/*-----------ver7.0 122004------------*/
if (strcmp(version, VERSION70) == 0) return TRUE;
/*---------end-ver7.0----------*/


  return FALSE;
} 


/*----------------------------------------------------------------------

  scaled_freq  --  return the scaled frequency

    input  -- freq: the frequency to be scaled;
    output -- none;

  funtion returns the scaled frequency.

------------------------------------------------------------------------*/
int scaled_freq(freq)
int freq;
{
  if (freq >= 1000) return 500;
  if (freq >= 900) return (freq*0.55);
  if (freq >= 800) return (freq*0.6);
  if (freq >= 700) return (freq*0.65);
  if (freq >= 600) return (freq*0.7);
  if (freq >= 500) return (freq*0.75);
  if (freq >= 400) return (freq*0.8);
  if (freq >= 300) return (freq*0.85);
  if (freq >= 200) return (freq*0.9);
  if (freq >= 100) return (freq*0.95);
  return freq;
}
