/*  Global Variables  */

struct  OneWord    onewddat[ONEWD_MAX];  /* working dictionary */
struct  DictIndex  dcm_dct[DCMDCT_MAX];  /* working dictionary index */

struct  UserWd     usrdctdat[ONEWD_MAX]; /* user dictionary */
struct  DictIndex  usr_dct[DCMDCT_MAX];  /* user dictionary index */

struct  WrongWord  wrongwd[WRONGWD_MAX]; /* wrong word list */

    
int    onewddat_ptr;      /* pointer of onewddat */
int    dcmdct_ptr;        /* pointer of dcm_dct */

int    usrdctdat_ptr;     /* pointer of usrdctdat */
int    usrdct_ptr;        /* pointer of usr_dct */

int    wrongwd_ptr;       /* pointer of wrongwd */
   
int    innertext[INNERTEXT_MAX];  /* array used to store inner text */
int    innertext_ptr;             /* pointer of innertext */

int    innertxtout[INNERTEXT_MAX]; /* array used to store updated inner
                                      text*/
int    innertxtout_ptr;            /* pointer of innertxtout */

int    dcmdct_head[MAXWORDLEN + 1]; /* words stored in user (working) 
                                       dictionary based on their length.
                                       words w/ same length are stored in
                                       the same red-black tree. 
                                       dcmdct_head stores the locations
                                       of the root for all different 
                                       trees in working dictionary */

int    usrdct_head[MAXWORDLEN + 1]; /* usrdct_head stores the locations
                                       of the root for all different 
                                       trees in user dictionary */

int    extral_alt[EXTRALTMAX];/* array used to store extral altenates of a 
                            wrong word */
int    extralt_ptr;      /* pointer of extral_alt */

int    err_hstry[RCNTERR_MAX + 1];  /* array used to store most recent
                                       error histories, it is considered
                                       as a circular queue */
int    errhstry_ptr = 0;      /* current pointer of err_hstry */
int    errhstry_head = 0;     /* head pointer of err_hstry */

    
int    itprt; /* count the number of altenates found for a wrong word */
int    Textwd;/* record the code of text word being currently processed*/
int    maxfrq = -1000; /*record the maximum frequence that a word occurs */


float  alpha;  /* coefficient to adjust the order of altenates */


char   Txt_Alt;  /* identify if the current word is a text word or 
                    altenate, 'T' for text word, 'A' for altenate */

char   Fnd_Not;  /* indicate if the current word  has been found in 
                    dictionary or not, 'F' for found, 'N' for not */

char   text_name[120]; /* hold the name of text being processed */

char   data_path[120]; /* hold the path to Laempel/Data */

char   wdfm_prg[120];  /* hold the name of file "onewd_wdfm.prg" */

char   act_prg[120];   /* hold the name of file "onewd_act.prg */


boolean  abccflg = FALSE;  /* TRUE:  print all inner information on screen;
                             FALSE: don't print. */

boolean  classify = FALSE;  /* TRUE:  ask user to specify classifications
                                      of user defined word;
                               FALSE: don't ask user to specify. */

boolean  accept_unknown = FALSE;  /* TRUE:  accept all unknown words 
                                            as correct.
                                     FALSE: do not accept unknown words as 
                                            correct automatically.  */

boolean  upper_head;  /* indicate if the 1st letter of the word is  upper */
boolean  all_upper;
boolean  has_nono;          /* indicate an excluded dictionary is loaded */

/*
char   err_report[2 * WRONGWD_MAX][MAXWORDLEN + 1]; */
                 /* record the list of wrong words and their corrected
                    words fixed by user */
/*int    errrpt_ptr;  *//*  pointer to err_report */

