#include  "spell_cnst.h" 

#include "spellroutines.h"

extern  char Txt_Alt, Fnd_Not;
extern  int  itprt;


int  is_wf, not_wf;


boolean cmb_sfx_ptrn();

  
int   Class_Name(pattern, classname, irglar)
char  pattern[], classname[][7];
int   *irglar;
      /* irglar = 1 if irregular noun only, 2 if irregular verb only */
{
  int len, i, j = 0;
  boolean has_rnoun = FALSE, has_rverb = FALSE, 
          has_inoun = FALSE, has_iverb = FALSE;
  
  *irglar = 0;
  len = strlen(pattern);
  for (i = 0; i < len; i++)
  {
    switch(pattern[i])
    {
      case 'n': strcpy(classname[j++], "noun");
                has_rnoun = TRUE;
                break;
      case 'o': has_inoun = TRUE;
                break;
      case 'N': strcpy(classname[j++], "plural");
                break;
      case 't': strcpy(classname[j++], "verbt");
                has_rverb = TRUE;
                break;
      case 'u': strcpy(classname[j++], "verbt");
                has_iverb = TRUE;
                break;
      case 'i': strcpy(classname[j++], "verbi");
                has_rverb = TRUE;
                break;
      case 'j': strcpy(classname[j++], "verbi");
                has_iverb = TRUE;
                break;
      case 'a': strcpy(classname[j++], "adj");
                break;
      case 'y': strcpy(classname[j++], "adv");
                break;
      case 'c': strcpy(classname[j++], "conj");
                break;
      case 'p': strcpy(classname[j++], "prep");
                break;
      case 'q': strcpy(classname[j++], "interj");
                break;
      case 's':
      case 'S':
      case 'r': strcpy(classname[j++], "pron");
                break;
      case 'E': strcpy(classname[j++], "dart");
                break;
      case 'e': strcpy(classname[j++], "iart");
                break;
      case 'x':
      case 'X': strcpy(classname[j++], "aux");
                break;
      case 'U': strcpy(classname[j++], "undef");
                break;
 
      case 'v': /* past vt */
      case 'V': /* past part. vt */
      case 'g': /* present part. vt */
      case 'k': /* past vi */
      case 'K': /* past part. vi */
      case 'G': /* present part. vi */
      case 'b': /* var of verb be (in present) */
      case 'B': /* var of verb be (in past) */
      case 'w': /* verb be */
      case 'W': /* been */
      case 'z': /* being */
      case 'd': /* verb do and its var (in present) */
      case 'D': /* verb do and its var (in past) */
      case 'h': /* verb have and its var (in present) */
      case 'H': /* verb have and its var (in past) */
      case 'A': /* abriviation */
      case 'l': /* linking verb */
      case '\'': /* ' */
                break;
      default:  break;

                /*printf("the class %c is not defined\n", pattern[i]);
                exit(0);*/
    };
  };
  if (has_inoun && (!has_rnoun) && (!has_rverb) && (!has_iverb)) *irglar = 1;
  if (has_iverb && (!has_rverb)) *irglar = 2;
  return(j); 
}

int      Is_vowel(ch)
char  ch;
{
  switch(ch)
  {
    case 'a': 
    case 'e':
    case 'i':
    case 'o':
    case 'u': return(TRUE);
              break;
    default:  return(FALSE);
  };
}

/***************************************************************************/
/*Function to check if the last consonant of the word should be doubled or */
/*not. Return 0 if the word is okay; 1 if the word should be doubled but it*/
/*didn't; 2 if the word should not be doubled but it did; 3 if the word    */
/*should be doubled and it did.                                            */
/***************************************************************************/
int  Is_sglvwl_sglcnsnt(root, suffix)
char root[], suffix[];
{
  int  len, i, d;
  char ch1, ch2, word[MAXWORDLEN + 1], pttrn[MAXPTRNS+1];
  
  len = strlen(root);
  i = len - 1;
  while ((i > 0) && (! Is_vowel(root[i])))  i--;
  
  if (i > 0)
  {
    ch1 = root[i - 1];
    if ((Is_vowel(ch1)) && (ch1 != 'u'))
    {
      if ((len - i) == 3)
      {
        ch1 = root[i + 1];
        ch2 = root[i + 2];
        if (ch1 == ch2) 
        {
          return(2);
        };
      };

      return(0);
    };
    
    if (ch1 == 'u') 
    {
      if (i > 1)
      {
        if (root[i - 2] != 'q')
        {
          return(0);
        };
      }
      else
      {
        return(0);
      };
    };

    strcpy(word, root);
    d = len - i;
    switch(d)
    {
      case 2:   strcat(word, suffix);
                if (Find_Word(word, pttrn)) return 0;
  
                strcpy(word, root);
                word[len] = word[len - 1];
                word[len + 1] = '\0';
                strcat(word, suffix);
                if (Find_Word(word, pttrn)) 
                {
                  if(pttrn[0] != 'U')
                  {
                    return(1);
                  }
                  else
                  {
                    return(0);
                  };
                }
                else
                {
                  return(0);
                };
                break;

      case 3:   ch1 = word[i + 1];
                ch2 = word[i + 2];
                if (ch1 != ch2) 
                {
                  return(0);
                }
                else
                {
                  if (Find_Word(word, pttrn)) return 0;

                  strcat(word, suffix);
                  if (Find_Word(word, pttrn)) 
                  {
                    if(pttrn[0] != 'U')
                    {
                      return(3);
                    }
                    else
                    {
                      return(2);
                    }; 
                  }
                  else
                  {
                    return(2);
                  };
                };
                break;

      default:  return(0);
    };
  }
  else
  {
    return(0);
  };
}

/***************************************************************************/
/*  Function to return the coding of predicate is_wf().                    */
/***************************************************************************/
int  iswf_code()
{
  int i, p, up, code;
  static char  var[129];

  up = ISWFIDX + 10;
  p = 1;
  code = 0;

  for (i = ISWFIDX; i < up; i ++)
  {
    if (getval(i, var))
    {
      code = code + p;
    };
    p = p * 2;
  };

  return(code);
}

/**************************************************************************/
/*  Function to return the coding of predicate not_wf().                  */
/**************************************************************************/
int  notwf_code()
{
  int i, p, up, code;
  static char  var[129];

  up = (NOTWFIDX + 10);
  p = 1;
  code = 0;

  for (i = NOTWFIDX; i < up; i ++)
  {
    if (getval(i, var))
    {
      code = code + p;
    };
    p = p * 2;
  };

  return(code);
}


int       Suffix_s(word, roots, pttrns)
char  word[], roots[], pttrns[];
{
  int          len, wdlen, i, irglar;
  char         cname[MAXPTRNS+1][7], ch1, ch2; 
  static char  var[129];
  int          found_s;

  found_s = FALSE;
  roots[0] = '\0';
  pttrns[0] = '\0';
  
  wdlen = strlen(word);

  strcpy(roots, word);
  roots[wdlen - 1] = '\0';
  if ((found_s = Find_Word(roots, pttrns)))
  {
    len = Class_Name(pttrns, cname, &irglar);
    if (irglar == 1)  { /* irregular noun only */
      roots[0] = '\0';
      pttrns[0] = '\0';
      return FALSE;
    }

    for (i = 0; i < len; i++)
    {
      strcpy(var, "ip_clsf(");
      strcat(var, cname[i]);
      strcat(var, ",s)");

      mstvar(var, 0, "T");
    };


    len = strlen(roots) - 1;
    ch1 = roots[len - 1];
    ch2 = roots[len];
    switch(ch2)
    {
      case 's':  strcpy(var, "ip_rtsf(s)");
                 mstvar(var, 0, "T");
                 break;
      case 'h':  if (ch1 == 's')
                 {
                   strcpy(var, "ip_rtsf(sh)");
                   mstvar(var, 0, "T");
                 };

                 if (ch1 == 'c')
                 {
                   strcpy(var, "ip_rtsf(ch)");
                   mstvar(var, 0, "T");
                 };

                 break;
      case 'x':  strcpy(var, "ip_rtsf(x)");
                 mstvar(var, 0, "T");
                 break;
      case 'y': if (! Is_vowel(ch1))
                {
                  strcpy(var, "ip_rtsf(cy)");
                  mstvar(var, 0, "T");
                };
                break;
  
    };                 
  }
  else
  {
    roots[0] = '\0';
    pttrns[0] = '\0'; 
  };

  return(found_s);
}


int Suffix_es(word, rootes, pttrnes)
char word[], rootes[], pttrnes[];
{

  int          len, wdlen, i, irglar;
  char         cname[MAXPTRNS+1][7], ch1, ch2, ptrns[MAXPTRNS+1]; 
  static char  var[129];
  int          found_es;


  found_es = FALSE;
  rootes[0] = '\0';
  pttrnes[0] = '\0';
  
  wdlen = strlen(word);
  strcpy(rootes, word);
  rootes[wdlen - 2] = '\0';
  if ((found_es = Find_Word(rootes, pttrnes)))
  {  
    len = Class_Name(pttrnes, cname, &irglar);
    if (irglar == 1)  { /* irregular noun only */
      rootes[0] = '\0';
      pttrnes[0] = '\0';
      return FALSE;
    }

    for (i = 0; i < len; i++)
    {
      strcpy(var, "ip_clsf(");
      strcat(var, cname[i]);
      strcat(var, ",es)");

      mstvar(var, 0, "T");
    };

    len = strlen(rootes) - 1;
    ch1 = rootes[len - 1];
    ch2 = rootes[len];
    switch(ch2)
    {
      case 's':  strcpy(var, "ip_rtsf(s)");
                 mstvar(var, 0, "T");
                 break;
      case 'h':  if (ch1 == 's')
                 {
                   strcpy(var, "ip_rtsf(sh)");
                   mstvar(var, 0, "T");
                 };

                 if (ch1 == 'c')
                 {
                   strcpy(var, "ip_rtsf(ch)");
                   mstvar(var, 0, "T");
                 };

                 break;
      case 'x':  strcpy(var, "ip_rtsf(x)");
                 mstvar(var, 0, "T");
                 break;

      case 'o':  if (!Is_vowel(ch1)) {
                   if (Find_Word(word, ptrns)) {
                     if (ptrns[0] != 'U') {
                       strcpy(var, "ip_rtsf(x)");
                       mstvar(var, 0, "T");
                     }
                   }
                 }
    };   
  }
  else
  {
    rootes[0] = '\0';
    pttrnes[0] = '\0'; 
  };

  return(found_es);

}


int       Suffix_ies(word, rooties, pttrnies)
char  word[], rooties[], pttrnies[];
{
  int          len, wdlen, i, irglar;
  char         cname[MAXPTRNS+1][7], ch1; 
  static char  var[129];
  int          found_ies;

  found_ies = FALSE;
  rooties[0] = '\0';
  pttrnies[0] = '\0';
  
  wdlen = strlen(word);

  strcpy(rooties, word);
  rooties[wdlen - 3] = 'y';
  rooties[wdlen - 2] = '\0';
  if ((found_ies = Find_Word(rooties, pttrnies)))
  {  
    len = Class_Name(pttrnies, cname, &irglar);
    if (irglar == 1)  { /* irregular noun only */
      rooties[0] = '\0';
      pttrnies[0] = '\0';
      return FALSE;
    }

    for (i = 0; i < len; i++)
    {
      strcpy(var, "ip_clsf(");
      strcat(var, cname[i]);
      strcat(var, ",ies)");

      mstvar(var, 0, "T");
    };

    len = strlen(rooties) - 1;
    ch1 = rooties[len - 1];
    if (Is_vowel(ch1))
    {
      strcpy(var, "ip_rtsf(vy)");
      mstvar(var, 0, "T");
    };
    
  }
  else
  {
    rooties[0] = '\0';
    pttrnies[0] = '\0'; 
  };

  return(found_ies);

}


void  Suffix_s_es_ies(token)
char   token[];
{
  char     word[MAXWORDLEN + 1], altword[MAXWORDLEN + 1], root[MAXWORDLEN + 1],
           pttrn[MAXPTRNS+1], cptrn[MAXPTRNS+1];
  int      wdlen;
  int      alt_es, alt_ies;

  
  strcpy(word, token);
  wdlen = strlen(word);

  if (Suffix_s(word, root, pttrn))
  {
    solprb();

    if (getval(0, "proper_wordform"))
    {
      is_wf = iswf_code();
      not_wf = notwf_code();
      
      if (cmb_sfx_ptrn("es", pttrn, cptrn)) {
/*        char pt[MAXPTRNS + 1];

        if (Find_Word(word, pt)) {
          if (pt[0] != 'U') {
            strcat(pt, cptrn);
            strcpy(cptrn, pt);
          }
        }*/
        inner_form(word, root, " ", cptrn, Txt_Alt, Fnd_Not, 
                   is_wf, not_wf, 0);
      }
      else {
        inner_form(word, root, "s", pttrn, Txt_Alt, Fnd_Not, 
                   is_wf, not_wf, 0);
      }

      Txt_Alt = 'B';

      rstprb("A");
    }
    else
    {
      if (getval(0, "violate_spelling"))
      {
        strcpy(altword, word);
        altword[wdlen - 1] = 'e';
        altword[wdlen] = 's';
        altword[wdlen + 1] = '\0';

        alt_es = FALSE;
        alt_ies = FALSE;

        rstprb("A");
                         
        if ((altword[wdlen - 2] == 'y') && (! Is_vowel(altword[wdlen - 3])))
        {
          altword[wdlen - 2] = 'i';
          alt_ies = Suffix_ies(altword, root, pttrn);
        }
        else
        {
          alt_es = Suffix_es(altword, root, pttrn);
        };

        if (alt_es || alt_ies)
        {
          solprb();

          if (getval(0, "proper_wordform"))
          {
            inner_form(word, " ", " ", " ", Txt_Alt, Fnd_Not, 0, 0, 0);
            Txt_Alt = 'A';

            is_wf = iswf_code();
            not_wf = notwf_code();
      
           /* printf("\nInterpretation %d: \n", itprt);*/
            if (alt_es)
            {
              /*printf("word: %s; root: %s; suffix: es; pattern:  %s\n", 
                      altword, root, pttrn);*/
              if (cmb_sfx_ptrn("es", pttrn, cptrn)) {
/*                char pt[MAXPTRNS + 1];

                if (Find_Word(word, pt)) {
                  if (pt[0] != 'U') {
                    strcat(pt, cptrn);
                    strcpy(cptrn, pt);
                  }
                }*/
                inner_form(altword, root, " ", cptrn, Txt_Alt, 'F', 
                           is_wf, not_wf, SPELLING);
              }
              else {
                inner_form(altword, root, "es", pttrn, Txt_Alt, 'F', 
                           is_wf, not_wf, SPELLING);
              }
            }
            else
            {
             /* printf("word: %s; root: %s; suffix: ies; pattern:  %s\n", 
                      altword, root, pttrn);*/
              if (cmb_sfx_ptrn("es", pttrn, cptrn)) {
  /*              char pt[MAXPTRNS + 1];

                if (Find_Word(word, pt)) {
                  if (pt[0] != 'U') {
                    strcat(pt, cptrn);
                    strcpy(cptrn, pt);
                  }
                }*/
                inner_form(altword, root, " ", cptrn, Txt_Alt, 'F', 
                           is_wf, not_wf, SPELLING);
              }
              else {
                inner_form(altword, root, "ies", pttrn, Txt_Alt, 'F', 
                           is_wf, not_wf, SPELLING);
              }
            }

            /*for (i = ISWFIDX; i < (NOTWFIDX + 10); i ++)
            {
              if (getval(i, var))
              {
                printf("%s\n", var);
              };
            };
            printf("violate_spelling\n");*/
          };
                             
          rstprb("A");
        };
      }
      else
      {
        rstprb("A");
      };
    };                      
  };
         
            
  if (word[wdlen - 2] == 'e')
  {
    if (Suffix_es(word, root, pttrn))
    {
      solprb();

      if (getval(0, "proper_wordform"))
      {
        is_wf = iswf_code();
        not_wf = notwf_code();
      
        if (cmb_sfx_ptrn("es", pttrn, cptrn)) {
          char pt[MAXPTRNS + 1];

          if (Find_Word(word, pt)) {
            if (pt[0] != 'U') {
              strcat(pt, cptrn);
              strcpy(cptrn, pt);
            }
          }
          inner_form(word, root, " ", cptrn, Txt_Alt, Fnd_Not, 
                     is_wf, not_wf, 0);
        }
        else {
          inner_form(word, root, "es", pttrn, Txt_Alt, Fnd_Not, 
                     is_wf, not_wf, 0);
        }

        if (Txt_Alt == 'T')
        {
          Txt_Alt = 'B';
        };

        rstprb("A");
      }
      else
      {
        if (getval(0, "violate_spelling"))
        {
          strcpy(altword, word);
          altword[wdlen - 2] = 's';
          altword[wdlen - 1] = '\0';
                                       
          rstprb("A");
  
          if (Suffix_s(altword, root, pttrn))
          {
            solprb();

            if (getval(0, "proper_wordform"))
            {
              if (Txt_Alt == 'T') {
                inner_form(word, " ", " ", " ", Txt_Alt, Fnd_Not, 0, 0, 0);
              }
              Txt_Alt = 'A';

              is_wf = iswf_code();
              not_wf = notwf_code();
            
              if (cmb_sfx_ptrn("es", pttrn, cptrn)) {
 /*               char pt[MAXPTRNS + 1];

                if (Find_Word(word, pt)) {
                  if (pt[0] != 'U') {
                    strcat(pt, cptrn);
                    strcpy(cptrn, pt);
                  }
                } */
                inner_form(altword, root, " ", cptrn, Txt_Alt, 'F', 
                           is_wf, not_wf, SPELLING);
              }
              else {
                inner_form(altword, root, "s", pttrn, Txt_Alt, 'F', 
                           is_wf, not_wf, SPELLING);
              }
            };                      

            rstprb("A");
                    
          };
        }
        else
        {
          rstprb("A");
        };
      };
    };
  };
                      
  if (word[wdlen - 3] == 'i')
  {
    if (Suffix_ies(word, root, pttrn))
    {
      solprb();

      if (getval(0, "proper_wordform"))
      {
        
        
        is_wf = iswf_code();
        not_wf = notwf_code();
      
        if (cmb_sfx_ptrn("es", pttrn, cptrn)) {
 /*         char pt[MAXPTRNS + 1];

          if (Find_Word(word, pt)) {
            if (pt[0] != 'U') {
              strcat(pt, cptrn);
              strcpy(cptrn, pt);
            }
          } */
          inner_form(word, root, " ", cptrn, Txt_Alt, Fnd_Not, 
                     is_wf, not_wf, 0);
        }
        else {
          inner_form(word, root, "ies", pttrn, Txt_Alt, Fnd_Not, 
                     is_wf, not_wf, 0);
        }

        if (Txt_Alt == 'T')
        {
          Txt_Alt = 'B';
        };
          
        rstprb("A");
      }
      else
      {
        if (getval(0, "violate_spelling"))
        {
          strcpy(altword, word);
          altword[wdlen - 3] = 'y';
          altword[wdlen - 2] = 's';
          altword[wdlen - 1] = '\0';
                                       
          rstprb("A");
  
          if (Suffix_s(altword, root, pttrn))
          {
            solprb();

            if (getval(0, "proper_wordform"))
            {
              if (Txt_Alt == 'T') {
              inner_form(word, " ", " ", " ", Txt_Alt, Fnd_Not, 0, 0, 0);
              }
              Txt_Alt = 'A';

              is_wf = iswf_code();
              not_wf = notwf_code();
      
             /* printf("\nInterpretation %d: \n", itprt);
              printf("word: %s; root: %s; suffix: s; pattern:  %s\n", 
                      altword, root, pttrn);*/

              if (cmb_sfx_ptrn("es", pttrn, cptrn)) {
 /*               char pt[MAXPTRNS + 1];

                if (Find_Word(word, pt)) {
                  if (pt[0] != 'U') {
                    strcat(pt, cptrn);
                    strcpy(cptrn, pt);
                  }
                }*/
                inner_form(altword, root, " ", cptrn, Txt_Alt, 'F', 
                           is_wf, not_wf, SPELLING);
              }
              else {
                inner_form(altword, root, "s", pttrn, Txt_Alt, 'F', 
                           is_wf, not_wf, SPELLING);
              }

             /* for (i = ISWFIDX; i < (NOTWFIDX + 10); i ++)
              {
                if (getval(i, var))
                {
                  printf("%s\n", var);
                };
              };
              printf("violate_spelling\n");*/
            };                 
              
            rstprb("A");

          };
        }
        else
        {
          rstprb("A");
        };
      };
    };
  };

} /* Suffix_s_es_ies */


int Suffix_d(word, rootd, pttrnd)
char  word[], rootd[], pttrnd[];
{
  int          len, wdlen, i, irglar;
  char         cname[MAXPTRNS+1][7], ch1, ch2; 
  static char  var[129];
  int          found_d;

  found_d = FALSE;
  rootd[0] = '\0';
  pttrnd[0] = '\0';
  
  wdlen = strlen(word);

  strcpy(rootd, word);
  rootd[wdlen - 1] = '\0';
  switch(Is_sglvwl_sglcnsnt(rootd, "ed"))
  {
    case 0: 
            if ((found_d = Find_Word(rootd, pttrnd)))
            {
              len = Class_Name(pttrnd, cname, &irglar);
              if (irglar == 2)  { /* irregular verb only */
                rootd[0] = '\0';
                pttrnd[0] = '\0';
                return FALSE;
              }

              for (i = 0; i < len; i++)
              {
                strcpy(var, "ip_clsf(");
                strcat(var, cname[i]);
                strcat(var, ",d)");

                mstvar(var, 0, "T");
              };

              len = strlen(rootd) - 1;
              ch1 = rootd[len - 1];
              ch2 = rootd[len];
              switch(ch2)
              {
                case 'e':  strcpy(var, "ip_rtsf(e)");
                           mstvar(var, 0, "T");
                           break;
                case 'y':  if (! Is_vowel(ch1))
                           {
                             strcpy(var, "ip_rtsf(cy)");
                             mstvar(var, 0, "T");
                           };
                           break;
              };   
     
            }
            else
            {
              rootd[0] = '\0';
              pttrnd[0] = '\0'; 
            };
            break;

    case 1:
            if ((found_d = Find_Word(rootd, pttrnd)))
            {
              len = Class_Name(pttrnd, cname, &irglar);
              if (irglar == 2)  { /* irregular verb only */
                rootd[0] = '\0';
                pttrnd[0] = '\0';
                return FALSE;
              }

              for (i = 0; i < len; i++)
              {
                strcpy(var, "ip_clsf(");
                strcat(var, cname[i]);
                strcat(var, ",d)");

                mstvar(var, 0, "T");
              };
              strcpy(var, "ip_rtsf(svsc)");
              mstvar(var, 0, "T");

            }
            else
            {
              rootd[0] = '\0';
              pttrnd[0] = '\0'; 
            };
            break;

    case 2: 
            rootd[wdlen - 2] = '\0';
            if ((found_d = Find_Word(rootd, pttrnd)))
            {
              len = Class_Name(pttrnd, cname, &irglar);
              if (irglar == 2)  { /* irregular verb only */
                rootd[0] = '\0';
                pttrnd[0] = '\0';
                return FALSE;
              }

              for (i = 0; i < len; i++)
              {
                strcpy(var, "ip_clsf(");
                strcat(var, cname[i]);
                strcat(var, ",d)");

                mstvar(var, 0, "T");
              };

              strcpy(var, "ip_rtsf(svdc)");
              mstvar(var, 0, "T");

            }
            else
            {
              rootd[wdlen - 2] = rootd[wdlen - 3];
              rootd[wdlen - 1] = '\0';
              if ((found_d = Find_Word(rootd, pttrnd)))
              {
                len = Class_Name(pttrnd, cname, &irglar);
                if (irglar == 2)  { /* irregular verb only */
                  rootd[0] = '\0';
                  pttrnd[0] = '\0';
                  return FALSE;
                }

                for (i = 0; i < len; i++)
                {
                  strcpy(var, "ip_clsf(");
                  strcat(var, cname[i]);
                  strcat(var, ",d)");

                  mstvar(var, 0, "T");
                };
              }
              else
              {
                rootd[0] = '\0';
                pttrnd[0] = '\0'; 
              };
            };
            break;

    case 3: 
            rootd[wdlen - 2] = '\0';
            if ((found_d = Find_Word(rootd, pttrnd)))
            {
              len = Class_Name(pttrnd, cname, &irglar);
              if (irglar == 2)  { /* irregular verb only */
                rootd[0] = '\0';
                pttrnd[0] = '\0';
                return FALSE;
              }

              for (i = 0; i < len; i++)
              {
                strcpy(var, "ip_clsf(");
                strcat(var, cname[i]);
                strcat(var, ",d)");

                mstvar(var, 0, "T");
              };

            }
            else
            {
              rootd[0] = '\0';
              pttrnd[0] = '\0'; 
            };
            break;       
  };
  return(found_d);

}


int  Suffix_ed(word, rooted, pttrned)
char  word[], rooted[], pttrned[];
{
  int          len, wdlen, i, irglar;
  char         cname[MAXPTRNS+1][7], ch1, ch2; 
  static char  var[129];
  int          found_ed;

  found_ed = FALSE;
  rooted[0] = '\0';
  pttrned[0] = '\0';
  
  wdlen = strlen(word);

  strcpy(rooted, word);
  rooted[wdlen - 2] = '\0';
  switch(Is_sglvwl_sglcnsnt(rooted, "ed"))
  {
    case 0: 
            if ((found_ed = Find_Word(rooted, pttrned)))
            {  
              len = Class_Name(pttrned, cname, &irglar);
              if (irglar == 2)  { /* irregular verb only */
                rooted[0] = '\0';
                pttrned[0] = '\0';
                return FALSE;
              }

              for (i = 0; i < len; i++)
              {
                strcpy(var, "ip_clsf(");
                strcat(var, cname[i]);
                strcat(var, ",ed)");

                mstvar(var, 0, "T");
              };
     
              len = strlen(rooted) - 1;
              ch1 = rooted[len - 1];
              ch2 = rooted[len];
              switch(ch2)
              {
                case 'e':  strcpy(var, "ip_rtsf(e)");
                           mstvar(var, 0, "T");
                           break;
                case 'y':  if (! Is_vowel(ch1))
                           {
                             strcpy(var, "ip_rtsf(cy)");
                             mstvar(var, 0, "T");
                           };
                           break;
              };   
 
            }
            else
            {
              rooted[0] = '\0';
              pttrned[0] = '\0'; 
            };
            break;

    case 1: 
            if ((found_ed = Find_Word(rooted, pttrned)))
            {  
              len = Class_Name(pttrned, cname, &irglar);
              if (irglar == 2)  { /* irregular verb only */
                rooted[0] = '\0';
                pttrned[0] = '\0';
                return FALSE;
              }

              for (i = 0; i < len; i++)
              {
                strcpy(var, "ip_clsf(");
                strcat(var, cname[i]);
                strcat(var, ",ed)");

                mstvar(var, 0, "T");
              };
     
              strcpy(var, "ip_rtsf(svsc)");
              mstvar(var, 0, "T");
            }
            else
            {
              rooted[0] = '\0';
              pttrned[0] = '\0'; 
            };
            break;

    case 2:
            rooted[wdlen - 3] = '\0';
            if ((found_ed = Find_Word(rooted, pttrned)))
            {  
              len = Class_Name(pttrned, cname, &irglar);
              if (irglar == 2)  { /* irregular verb only */
                rooted[0] = '\0';
                pttrned[0] = '\0';
                return FALSE;
              }

              for (i = 0; i < len; i++)
              {
                strcpy(var, "ip_clsf(");
                strcat(var, cname[i]);
                strcat(var, ",ed)");

                mstvar(var, 0, "T");
              };

              strcpy(var, "ip_rtsf(svdc)");
              mstvar(var, 0, "T");

            }
            else
            {
              rooted[wdlen - 3] = rooted[wdlen - 4];
              rooted[wdlen - 2] = '\0';
              if ((found_ed = Find_Word(rooted, pttrned)))
              {  
                len = Class_Name(pttrned, cname, &irglar);
                if (irglar == 2)  { /* irregular verb only */
                  rooted[0] = '\0';
                  pttrned[0] = '\0';
                  return FALSE;
                }

                for (i = 0; i < len; i++)
                {
                  strcpy(var, "ip_clsf(");
                  strcat(var, cname[i]);
                  strcat(var, ",ed)");

                  mstvar(var, 0, "T");
                };
              }
              else
              {
                rooted[0] = '\0';
                pttrned[0] = '\0'; 
              };
            };
            break;

    case 3: 
            rooted[wdlen - 3] = '\0';
            if ((found_ed = Find_Word(rooted, pttrned)))
            {  
              len = Class_Name(pttrned, cname, &irglar);
              if (irglar == 2)  { /* irregular verb only */
                rooted[0] = '\0';
                pttrned[0] = '\0';
                return FALSE;
              }

              for (i = 0; i < len; i++)
              {
                strcpy(var, "ip_clsf(");
                strcat(var, cname[i]);
                strcat(var, ",ed)");

                mstvar(var, 0, "T");
              };

            }
            else
            {
              rooted[0] = '\0';
              pttrned[0] = '\0'; 
            };
            break;
  };

  return(found_ed);
}

int  Suffix_ied(word, rootied, pttrnied)
char  word[], rootied[], pttrnied[];
{
  int          len, wdlen, i, irglar;
  char         cname[MAXPTRNS+1][7], ch1; 
  static char  var[129];
  int          found_ied;

  
  found_ied = FALSE;
  rootied[0] = '\0';
  pttrnied[0] = '\0';
  
  wdlen = strlen(word);

  strcpy(rootied, word);
  rootied[wdlen - 3] = 'y';
  rootied[wdlen - 2] = '\0';
  if ((found_ied = Find_Word(rootied, pttrnied)))
  {  
    len = Class_Name(pttrnied, cname, &irglar);
    if (irglar == 2)  { /* irregular verb only */
      rootied[0] = '\0';
      pttrnied[0] = '\0';
      return FALSE;
    }

    for (i = 0; i < len; i++)
    {
      strcpy(var, "ip_clsf(");
      strcat(var, cname[i]);
      strcat(var, ",ied)");

      mstvar(var, 0, "T");
    };

    len = strlen(rootied) - 1;
    ch1 = rootied[len - 1];
    if (Is_vowel(ch1))
    {
      strcpy(var, "ip_rtsf(vy)");
      mstvar(var, 0, "T");
    };
      
  }
  else
  { 
    rootied[0] = '\0';
    pttrnied[0] = '\0'; 
  };

  return(found_ied);
}

void  Suffix_d_ed_ied(token)
char   token[];
{
  char     word[MAXWORDLEN + 1], altword[MAXWORDLEN + 1], root[MAXWORDLEN + 1],
           pttrn[MAXPTRNS+1], cptrn[MAXPTRNS+1];
  int      wdlen;
  int      alt_d, alt_ed, alt_ied, Txtwd_stored;
  boolean  svsc, svdc;

  Txtwd_stored = FALSE;
  strcpy(word, token);
  wdlen = strlen(word);

  if (Suffix_d(word, root, pttrn))
  {
    solprb();

    if (getval(0, "proper_wordform"))
    {
      /*printf("\nInterpretation %d: \n", itprt);
      printf("word: %s; root: %s; suffix: d; pattern: %s\n", word, root, pttrn);
      for (i = ISWFIDX; i < (NOTWFIDX + 10); i ++)
      {
        if (getval(i, var))
        {
          printf("%s\n", var);
        };
      };*/
      
      is_wf = iswf_code();
      not_wf = notwf_code();

      if (cmb_sfx_ptrn("ed", pttrn, cptrn)) {
        inner_form(word, root, " ", cptrn, Txt_Alt, Fnd_Not, 
                   is_wf, not_wf, 0);
      }
      else { 
        inner_form(word, root, "d", pttrn, Txt_Alt, Fnd_Not, 
                   is_wf, not_wf, 0);
      }

      Txtwd_stored = TRUE;
      Txt_Alt = 'B';

             
      rstprb("A");
    }
    else
    {
      if (getval(0, "violate_spelling"))
      {
        svsc = getval(0, "ip_rtsf(svsc)");
        svdc = getval(0, "ip_rtsf(svdc)");
        strcpy(altword, word);
        
        alt_ed = FALSE;
        alt_ied = FALSE;

        rstprb("A");
                         
        if ((altword[wdlen - 2] == 'y') && (! Is_vowel(altword[wdlen - 3])))
        {
          altword[wdlen - 2] = 'i';
          altword[wdlen - 1] = 'e';
          altword[wdlen] = 'd';
          altword[wdlen + 1] = '\0';
          alt_ied = Suffix_ied(altword, root, pttrn);
        }
        else
        {
          if (svsc)
          { 
            altword[wdlen - 1] = altword[wdlen - 2];
            altword[wdlen] = 'e';
            altword[wdlen + 1] = 'd';
            altword[wdlen + 2] = '\0';
          }
          else  
          {
            if (svdc)
            {
              altword[wdlen - 2] = 'e';
              altword[wdlen - 1] = 'd';
              altword[wdlen] = '\0';
            }
            else /* 'e' is missing */
            {
              altword[wdlen - 1] = 'e';
              altword[wdlen] = 'd';
              altword[wdlen + 1] = '\0';
            };

          };
            


          alt_ed = Suffix_ed(altword, root, pttrn);
        };

        if (alt_ed || alt_ied)
        {
          solprb();

          if (getval(0, "proper_wordform"))
          {
            inner_form(word, " ", " ", " ", Txt_Alt, Fnd_Not, 0, 0, 0);
            Txt_Alt = 'A';
            Txtwd_stored = TRUE;

            is_wf = iswf_code();
            not_wf = notwf_code();

           /* printf("\nInterpretation %d: \n", itprt);*/
            if (alt_ed)
            {
              /*printf("word: %s; root: %s; suffix: ed; pattern:  %s\n", 
                      altword, root, pttrn);*/
              if (cmb_sfx_ptrn("ed", pttrn, cptrn)) {
                inner_form(altword, root, " ", cptrn, Txt_Alt, 'F', 
                           is_wf, not_wf, SPELLING);
              }
              else {
                inner_form(altword, root, "ed", pttrn, Txt_Alt, 'F', 
                           is_wf, not_wf, SPELLING);
              }
            }
            else
            {
             /* printf("word: %s; root: %s; suffix: ied; pattern:  %s\n", 
                      altword, root, pttrn);*/
              if (cmb_sfx_ptrn("ed", pttrn, cptrn)) {
                inner_form(altword, root, " ", cptrn, Txt_Alt, 'F', 
                           is_wf, not_wf, SPELLING);
              }
              else {
                inner_form(altword, root, "ied", pttrn, Txt_Alt, 'F', 
                           is_wf, not_wf, SPELLING);
              }
            }

           /* for (i = ISWFIDX; i < (NOTWFIDX + 10); i ++)
            {
              if (getval(i, var))
              {
                printf("%s\n", var);
              };
            };
            printf("violate_spelling\n");*/
          };
                             
          rstprb("A");
        };
      }
      else
      {
        rstprb("A");
      };
    };                      
  };
                         
  if (word[wdlen - 2] == 'e')
  {
    if (Suffix_ed(word, root, pttrn))
    {
      solprb();

      if (getval(0, "proper_wordform"))
      {
        /*printf("\nInterpretation %d: \n", itprt);
        printf("word: %s; root: %s; suffix: ed; pattern: %s\n", 
                word, root,pttrn);
        for (i = ISWFIDX; i < (NOTWFIDX + 10); i ++)
        {
          if (getval(i, var))
          {
            printf("%s\n", var);
          };
        };*/
          
        
        is_wf = iswf_code();
        not_wf = notwf_code();
      
        if (cmb_sfx_ptrn("ed", pttrn, cptrn)) {
          inner_form(word, root, " ", cptrn, Txt_Alt, Fnd_Not, 
                     is_wf, not_wf, 0);
        }
        else {
          inner_form(word, root, "ed", pttrn, Txt_Alt, Fnd_Not, 
                     is_wf, not_wf, 0);
        }

        if (Txt_Alt == 'T')
        {
          Txt_Alt = 'B';
        };

                   
        rstprb("A");
      }
      else
      {
        if (getval(0, "violate_spelling"))
        {
          svsc = getval(0, "ip_rtsf(svsc)");
          strcpy(altword, word);
        
          alt_d = FALSE;
          alt_ed = FALSE;
          alt_ied = FALSE;

          rstprb("A");
                         
          if ((altword[wdlen - 3] == 'y') && (! Is_vowel(altword[wdlen - 4])))
          {
            altword[wdlen - 3] = 'i';
            alt_ied = Suffix_ied(altword, root, pttrn);
          }
          else
          {
            if (altword[wdlen - 3] == 'e')
            {
              altword[wdlen - 2] = 'd';
              altword[wdlen - 1] = '\0';
              alt_d = Suffix_d(altword, root, pttrn);
            }
            else
            {
              if(svsc)
              {
                altword[wdlen - 2] = altword[wdlen - 3];
                altword[wdlen - 1] = 'e';
                altword[wdlen] = 'd';
                altword[wdlen + 1] = '\0';
              }
              else  /* ip_rtsf(svdc) == TRUE */
              {
                altword[wdlen - 3] = 'e';
                altword[wdlen - 2] = 'd';
                altword[wdlen - 1] = '\0';
              };
            
              alt_ed = Suffix_ed(altword, root, pttrn);
            };

          };

          if (alt_d || alt_ed || alt_ied)
          {
            solprb();

            if (getval(0, "proper_wordform"))
            {
              if (! Txtwd_stored)
              {
                inner_form(word, " ", " ", " ", Txt_Alt, Fnd_Not, 0, 0, 0);
                Txt_Alt = 'A';
                Txtwd_stored = TRUE;
              };

              is_wf = iswf_code();
              not_wf = notwf_code();
      

              /*printf("\nInterpretation %d: \n", itprt);*/
              if (alt_d)
              {
                /*printf("word: %s; root: %s; suffix: d; pattern:  %s\n", 
                        altword, root, pttrn);*/
                if (cmb_sfx_ptrn("ed", pttrn, cptrn)) {
                  inner_form(altword, root, " ", cptrn, Txt_Alt, 'F', 
                             is_wf, not_wf, SPELLING);
                }
                else {
                  inner_form(altword, root, "d", pttrn, Txt_Alt, 'F', 
                             is_wf, not_wf, SPELLING);
                }
              }
              else
              {
                if (alt_ed)
                {
                  /*printf("word: %s; root: %s; suffix: ed; pattern:  %s\n", 
                          altword, root, pttrn);*/
                  if (cmb_sfx_ptrn("ed", pttrn, cptrn)) {
                    inner_form(altword, root, " ", cptrn, Txt_Alt, 'F', 
                               is_wf, not_wf, SPELLING);
                  }
                  else {
                    inner_form(altword, root, "ed", pttrn, Txt_Alt, 'F', 
                               is_wf, not_wf, SPELLING);
                  }
                }  
                else
                {
                  /*printf("word: %s; root: %s; suffix: ied; pattern:  %s\n", 
                          altword, root, pttrn);*/
                  if (cmb_sfx_ptrn("ed", pttrn, cptrn)) {
                    inner_form(altword, root, " ", cptrn, Txt_Alt, 'F', 
                               is_wf, not_wf, SPELLING);
                  }
                  else {
                    inner_form(altword, root, "ied", pttrn, Txt_Alt, 'F', 
                               is_wf, not_wf, SPELLING);
                  }
                };
              };

              /*for (i = ISWFIDX; i < (NOTWFIDX + 10); i ++)
              {
                if (getval(i, var))
                {
                 printf("%s\n", var);
                };
              };
              printf("violate_spelling\n");*/
            };
                             
            rstprb("A");

          };
        }
        else
        {
          rstprb("A");
        };
      };
    };
  };
                     
  if (word[wdlen - 3] == 'i')
  {
    if (Suffix_ied(word, root, pttrn))
    {
      solprb();

      if (getval(0, "proper_wordform"))
      {
        /*printf("\nInterpretation %d: \n", itprt);
        printf("word: %s; root: %s; suffix: ied; pattern:  %s\n",
                word, root, pttrn);
        for (i = ISWFIDX; i < (NOTWFIDX + 10); i ++)
        {
          if (getval(i, var))
          {
            printf("%s\n", var);
          };
        };*/
           
        
        is_wf = iswf_code();
        not_wf = notwf_code();
      
        if (cmb_sfx_ptrn("ed", pttrn, cptrn)) {
          inner_form(word, root, " ", cptrn, Txt_Alt, Fnd_Not, 
                     is_wf, not_wf, 0);
        }
        else {
          inner_form(word, root, "ied", pttrn, Txt_Alt, Fnd_Not, 
                     is_wf, not_wf, 0);
        }

        if (Txt_Alt == 'T')
        {
          Txt_Alt = 'B';
        };

                  
        rstprb("A");
      }
      else
      {
        if (getval(0, "violate_spelling"))
        {
          strcpy(altword, word);
          altword[wdlen - 3] = 'y';
                                                 
          rstprb("A");
  
          if (Suffix_ed(altword, root, pttrn))
          {
            solprb();

            if (getval(0, "proper_wordform"))
            {
              if (! Txtwd_stored)
              {
                inner_form(word, " ", " ", " ", Txt_Alt, Fnd_Not, 0, 0, 0);
                Txt_Alt = 'A';
                Txtwd_stored = TRUE;
              };

              is_wf = iswf_code();
              not_wf = notwf_code();
      
              /*printf("\nInterpretation %d: \n", itprt);
              printf("word: %s; root: %s; suffix: ed; pattern:  %s\n", 
                      altword, root, pttrn);*/

              if (cmb_sfx_ptrn("ed", pttrn, cptrn)) {
                inner_form(altword, root, " ", cptrn, Txt_Alt, 'F', 
                           is_wf, not_wf, SPELLING);
              }
              else {
                inner_form(altword, root, "ed", pttrn, Txt_Alt, 'F', 
                           is_wf, not_wf, SPELLING);
              }

              /*for (i = ISWFIDX; i < (NOTWFIDX + 10); i ++)
              {
                if (getval(i, var))
                {
                  printf("%s\n", var);
                };
              };
              printf("violate_spelling\n");*/
            };                 
              
            rstprb("A");

          };
        }
        else
        {
          rstprb("A");
        };
      };
    };
  };
} /* Suffix_d_ed_ied */

int Suffix_ing(word, root, pttrn, check_e_only)
char  word[], root[], pttrn[];
boolean check_e_only;
{
  int          len, wdlen, i, irglar;
  char         cname[MAXPTRNS+1][7], ch1, ch2; 
  static char  var[129];
  int          found;

  found = FALSE;

  root[0] = '\0';
 
  pttrn[0] = '\0';
 
  wdlen = strlen(word);

  if (check_e_only) goto check_e;

  strcpy(root, word);
  root[wdlen - 3] = '\0';
  switch(Is_sglvwl_sglcnsnt(root, "ing"))
  {
    case 0: 
            if ((found = Find_Word(root, pttrn)))
            {
              len = Class_Name(pttrn, cname, &irglar);

              for (i = 0; i < len; i++)
              {
                strcpy(var, "ip_clsf(");
                strcat(var, cname[i]);
                strcat(var, ",ing)");

                mstvar(var, 0, "T");
              };

              len = strlen(root) - 1;
              ch1 = root[len - 1];
              ch2 = root[len];
              if ((ch2 == 'e') && ((! Is_vowel(ch1)) || (ch1 == 'u')))
              {
                strcpy(var, "ip_rtsf(ce)");
                mstvar(var, 0, "T");
              };   
            }
            else
            {
              root[0] = '\0';
              pttrn[0] = '\0'; 
            };
            break;

    case 1: 
            if ((found = Find_Word(root, pttrn)))
            {
              len = Class_Name(pttrn, cname, &irglar);

              for (i = 0; i < len; i++)
              {
                strcpy(var, "ip_clsf(");
                strcat(var, cname[i]);
                strcat(var, ",ing)");

                mstvar(var, 0, "T");
              };

              strcpy(var, "ip_rtsf(svsc)");
              mstvar(var, 0, "T");
            }
            else
            {
              root[0] = '\0';
              pttrn[0] = '\0'; 
            };
            break;


    case 2: 
            root[wdlen - 4] = '\0';
            if ((found = Find_Word(root, pttrn)))
            {
              len = Class_Name(pttrn, cname, &irglar);

              for (i = 0; i < len; i++)
              {
                strcpy(var, "ip_clsf(");
                strcat(var, cname[i]);
                strcat(var, ",ing)");

                mstvar(var, 0, "T");
              };

              strcpy(var, "ip_rtsf(svdc)");
              mstvar(var, 0, "T");
            }
            else
            {
              root[wdlen - 4] = root[wdlen - 5];
              root[wdlen - 3] = '\0';
              if ((found = Find_Word(root, pttrn)))
              {  
                len = Class_Name(pttrn, cname, &irglar);

                for (i = 0; i < len; i++)
                {
                  strcpy(var, "ip_clsf(");
                  strcat(var, cname[i]);
                  strcat(var, ",ing)");

                  mstvar(var, 0, "T");
                };
              }
              else
              {
                root[0] = '\0';
                pttrn[0] = '\0'; 
              };
            };
            break;

    case 3: 
            root[wdlen - 4] = '\0';
            if ((found = Find_Word(root, pttrn)))
            {
              len = Class_Name(pttrn, cname, &irglar);

              for (i = 0; i < len; i++)
              {
                strcpy(var, "ip_clsf(");
                strcat(var, cname[i]);
                strcat(var, ",ing)");

                mstvar(var, 0, "T");
              };
            }
            else
            {
              root[0] = '\0';
              pttrn[0] = '\0'; 
              
            };
            break;

  };

check_e:

  if(!found)
  {  
    if ((! Is_vowel(word[wdlen - 4])) || (word[wdlen - 4] == 'u'))
    {    
      root[0] = '\0';
      pttrn[0] = '\0'; 
    
      strcpy(root, word);
      root[wdlen - 3] = 'e';
      root[wdlen - 2] = '\0';
      if ((found = Find_Word(root, pttrn)))
      {
        len = Class_Name(pttrn, cname, &irglar);

        for (i = 0; i < len; i++)
        {
          strcpy(var, "ip_clsf(");
          strcat(var, cname[i]);
          strcat(var, ",ing)");

          mstvar(var, 0, "T");
        };
      }
      else
      {
        root[0] = '\0';
        pttrn[0] = '\0';
      };
    }
    else
    {
      root[0] = '\0';
      pttrn[0] = '\0'; 
    };
  };

  return(found);
 
} /* Suffix_ing */


void  Suffix_ING(token)

char   token[];


{
  char     word[MAXWORDLEN + 1], altword[MAXWORDLEN + 1], root[MAXWORDLEN + 1],
           pttrn[MAXPTRNS+1], cptrn[MAXPTRNS+1];
  int      wdlen;

  
  strcpy(word, token);
  wdlen = strlen(word);

  if (Suffix_ing(word, root, pttrn, FALSE))
  {
    solprb();

    if (getval(0, "proper_wordform"))
    {
      /*printf("\nInterpretation %d: \n", itprt);
      printf("word: %s; root: %s; suffix: ing; pattern: %s\n", word,root,pttrn);
      for (i = ISWFIDX; i < (NOTWFIDX + 10); i ++)
      {
        if (getval(i, var))
        {
          printf("%s\n", var);
        };
      };*/
      
      is_wf = iswf_code();
      not_wf = notwf_code();

      if (cmb_sfx_ptrn("ing", pttrn, cptrn)) {
        inner_form(word, root, " ", cptrn, Txt_Alt, Fnd_Not,
                   is_wf, not_wf, 0);
      }
      else {
        inner_form(word, root, "ing", pttrn, Txt_Alt, Fnd_Not,
                   is_wf, not_wf, 0);
      }

      Txt_Alt = 'A';

             
      rstprb("A");
    }
    else
    {
      if (getval(0, "violate_spelling"))
      {
        strcpy(altword, word);
        if (altword[wdlen - 4] == 'e')
        {
          altword[wdlen - 4] = 'i';
          altword[wdlen - 3] = 'n';
          altword[wdlen - 2] = 'g';
          altword[wdlen - 1] = '\0';
        }
        else
        {
          if (getval(0, "ip_rtsf(svsc)"))
          {
            rstprb("A");
            if (Suffix_ing(altword, root, pttrn, TRUE)) {
              solprb();
              if (getval(0, "proper_wordform")) {
                is_wf = iswf_code();
                not_wf = notwf_code();
                if (cmb_sfx_ptrn("ing", pttrn, cptrn)) {
                  inner_form(word, root, " ", cptrn, Txt_Alt, Fnd_Not, 
                             is_wf, not_wf, 0);
                }
                else {
                  inner_form(word, root, "ing", pttrn, Txt_Alt, Fnd_Not, 
                             is_wf, not_wf, 0);
                }

                Txt_Alt = 'A';
                rstprb("A");
                return;
              }
            }

            altword[wdlen - 3] = altword[wdlen - 4];
            altword[wdlen - 2] = 'i';
            altword[wdlen - 1] = 'n';
            altword[wdlen] = 'g';
            altword[wdlen + 1] = '\0';
          }
          else  /* ip_rtsf(svdc) == TRUE */
          {
            altword[wdlen - 4] = 'i';
            altword[wdlen - 3] = 'n';
            altword[wdlen - 2] = 'g';
            altword[wdlen - 1] = '\0';
          };
        };

        rstprb("A");
                         
        if (Suffix_ing(altword, root, pttrn, FALSE))
        {
          solprb();

          if (getval(0, "proper_wordform"))
          {
            inner_form(word, " ", " ", " ", Txt_Alt, Fnd_Not, 0, 0, 0);
            Txt_Alt = 'A';
            /*printf("\nInterpretation %d: \n", itprt);
            printf("word: %s; root: %s; suffix: ing; pattern:  %s\n", 
                    altword, root, pttrn);*/

            is_wf = iswf_code();
            not_wf = notwf_code();
      
            if (cmb_sfx_ptrn("ing", pttrn, cptrn)) {
              inner_form(altword, root, " ", cptrn, Txt_Alt, 'F', 
                         is_wf, not_wf, SPELLING);
            }
            else {
              inner_form(altword, root, "ing", pttrn, Txt_Alt, 'F', 
                       is_wf, not_wf, SPELLING);
            }

            /*for (i = ISWFIDX; i < (NOTWFIDX + 10); i ++)
            {
              if (getval(i, var))
              {
                printf("%s\n", var);
              };
            };
            printf("violate_spelling\n");*/
          };
                             
          rstprb("A");
        };
      }
      else
      {
        rstprb("A");
      }
    }                   
  }
} /* Suffix_ING */


int Suffix_r(word, rootr, pttrnr)
char  word[], rootr[], pttrnr[];
{
  int          len, wdlen, i, irglar;
  char         cname[MAXPTRNS+1][7], ch1, ch2; 
  static char  var[129];
  int          found_r;
  
  found_r = FALSE;
  
  rootr[0] = '\0';
  
  pttrnr[0] = '\0';
  
  wdlen = strlen(word);

  strcpy(rootr, word);
  rootr[wdlen - 1] = '\0';
  switch(Is_sglvwl_sglcnsnt(rootr, "er"))
  {
    case 0: 
            if ((found_r = Find_Word(rootr, pttrnr)))
            {
              len = Class_Name(pttrnr, cname, &irglar);

              for (i = 0; i < len; i++)
              {
                strcpy(var, "ip_clsf(");
                strcat(var, cname[i]);
                strcat(var, ",r)");

                mstvar(var, 0, "T");
              };


              len = strlen(rootr) - 1;
              ch1 = rootr[len - 1];
              ch2 = rootr[len];
              switch(ch2)
              {
                case 'e':  strcpy(var, "ip_rtsf(e)");
                           mstvar(var, 0, "T");
                           break;
                case 'y':  if (! Is_vowel(ch1))
                           {
                             strcpy(var, "ip_rtsf(cy)");
                              mstvar(var, 0, "T");
                           };
                           break;
              };   
            }
            else
            {
              rootr[0] = '\0';
              pttrnr[0] = '\0'; 
            };
            break;

    case 1: 
            if ((found_r = Find_Word(rootr, pttrnr)))
            {
              len = Class_Name(pttrnr, cname, &irglar);

              for (i = 0; i < len; i++)
              {
                strcpy(var, "ip_clsf(");
                strcat(var, cname[i]);
                strcat(var, ",r)");

                mstvar(var, 0, "T");
              };
              strcpy(var, "ip_rtsf(svsc)");
              mstvar(var, 0, "T");

            }
            else
            {
              rootr[0] = '\0';
              pttrnr[0] = '\0'; 
            };
            break;

   
    case 2:
            rootr[wdlen - 2] = '\0';
            if ((found_r = Find_Word(rootr, pttrnr)))
            {
              len = Class_Name(pttrnr, cname, &irglar);

              for (i = 0; i < len; i++)
              {
                strcpy(var, "ip_clsf(");
                strcat(var, cname[i]);
                strcat(var, ",r)");

                mstvar(var, 0, "T");
              };
              
              strcpy(var, "ip_rtsf(svdc)");
              mstvar(var, 0, "T");

            }
            else
            {
              rootr[wdlen - 2] = rootr[wdlen - 3];
              rootr[wdlen - 1] = '\0';
              if ((found_r = Find_Word(rootr, pttrnr)))
              {
                len = Class_Name(pttrnr, cname, &irglar);

                for (i = 0; i < len; i++)
                {
                  strcpy(var, "ip_clsf(");
                  strcat(var, cname[i]);
                  strcat(var, ",r)");

                  mstvar(var, 0, "T");
                };
              }
              else
              {
                rootr[0] = '\0';
                pttrnr[0] = '\0'; 
              };
            };
            break;

    case 3:
            rootr[wdlen - 2] = '\0';
            if ((found_r = Find_Word(rootr, pttrnr)))
            {
              len = Class_Name(pttrnr, cname, &irglar);

              for (i = 0; i < len; i++)
              {
                strcpy(var, "ip_clsf(");
                strcat(var, cname[i]);
                strcat(var, ",r)");

                mstvar(var, 0, "T");
              };
            }
            else
            {
              rootr[0] = '\0';
              pttrnr[0] = '\0'; 
             
            };
            break;
  };  
  return(found_r);
}

int Suffix_er(word, rooter, pttrner)
char  word[], rooter[], pttrner[];
{

  int          len, wdlen, i, irglar;
  char         cname[MAXPTRNS+1][7], ch1, ch2; 
  static char  var[129];
  int          found_er;
  

  found_er = FALSE;
  
  rooter[0] = '\0';
  
  pttrner[0] = '\0';
  
  wdlen = strlen(word);

  strcpy(rooter, word);
  rooter[wdlen - 2] = '\0';
  switch(Is_sglvwl_sglcnsnt(rooter, "er"))
  {
    case 0: 
            if ((found_er = Find_Word(rooter, pttrner)))
            {  
              len = Class_Name(pttrner, cname, &irglar);

              for (i = 0; i < len; i++)
              {
                strcpy(var, "ip_clsf(");
                strcat(var, cname[i]);
                strcat(var, ",er)");

                mstvar(var, 0, "T");
              };


              len = strlen(rooter) - 1;
              ch1 = rooter[len - 1];
              ch2 = rooter[len];
              switch(ch2)
              {
                case 'e':  strcpy(var, "ip_rtsf(e)");
                           mstvar(var, 0, "T");
                           break;
                case 'y':  if (! Is_vowel(ch1))
                           {
                             strcpy(var, "ip_rtsf(cy)");
                             mstvar(var, 0, "T");
                           };
                           break;
              };
            }
            else
            {
              rooter[0] = '\0';
              pttrner[0] = '\0';
            };
            break;

    case 1: 
            if ((found_er = Find_Word(rooter, pttrner)))
            {  
              len = Class_Name(pttrner, cname, &irglar);

              for (i = 0; i < len; i++)
              {
                strcpy(var, "ip_clsf(");
                strcat(var, cname[i]);
                strcat(var, ",er)");

                mstvar(var, 0, "T");
              };

              strcpy(var, "ip_rtsf(svsc)");
              mstvar(var, 0, "T");
            }
            else
            {
              rooter[0] = '\0';
              pttrner[0] = '\0';
            };
            break;
  
    case 2:
            rooter[wdlen - 3] = '\0';
            if ((found_er = Find_Word(rooter, pttrner)))
            {
              len = Class_Name(pttrner, cname, &irglar);

              for (i = 0; i < len; i++)
              {
                strcpy(var, "ip_clsf(");
                strcat(var, cname[i]);
                strcat(var, ",er)");

                mstvar(var, 0, "T");
              };
              
              strcpy(var, "ip_rtsf(svdc)");
              mstvar(var, 0, "T");

            }
            else
            {
              rooter[wdlen - 3] = rooter[wdlen - 4];
              rooter[wdlen - 2] = '\0';
              if ((found_er = Find_Word(rooter, pttrner)))
              {
                len = Class_Name(pttrner, cname, &irglar);

                for (i = 0; i < len; i++)
                {
                  strcpy(var, "ip_clsf(");
                  strcat(var, cname[i]);
                  strcat(var, ",er)");

                  mstvar(var, 0, "T");
                };
              }
              else
              {
                rooter[0] = '\0';
                pttrner[0] = '\0';
              };
            };
            break;

    case 3:
            rooter[wdlen - 3] = '\0';
            if ((found_er = Find_Word(rooter, pttrner)))
            {
              len = Class_Name(pttrner, cname, &irglar);

              for (i = 0; i < len; i++)
              {
                strcpy(var, "ip_clsf(");
                strcat(var, cname[i]);
                strcat(var, ",er)");

                mstvar(var, 0, "T");
              };
            }
            else
            {
              rooter[0] = '\0';
              pttrner[0] = '\0';
            };
            break;
  };
   
  return(found_er);
}


int Suffix_ier(word, rootier, pttrnier)
char  word[], rootier[], pttrnier[];
{
  int          len, wdlen, i, irglar;
  char         cname[MAXPTRNS+1][7], ch1; 
  static char  var[129];
  int          found_ier;
  
  found_ier = FALSE;
  
  rootier[0] = '\0';
  
  pttrnier[0] = '\0';
  
  wdlen = strlen(word);

  strcpy(rootier, word);
  rootier[wdlen - 3] = 'y';
  rootier[wdlen - 2] = '\0';

  if ((found_ier = Find_Word(rootier, pttrnier)))
  {  
    len = Class_Name(pttrnier, cname, &irglar);

    for (i = 0; i < len; i++)
    {
      strcpy(var, "ip_clsf(");
      strcat(var, cname[i]);
      strcat(var, ",ier)");

      mstvar(var, 0, "T");
    };


    len = strlen(rootier) - 1;
    ch1 = rootier[len - 1];
    if (Is_vowel(ch1))
    {
      strcpy(var, "ip_rtsf(vy)");
      mstvar(var, 0, "T");
    };
  }
  else
  {
    rootier[0] = '\0';
    pttrnier[0] = '\0'; 
  };

  return(found_ier);
}

void  Suffix_r_er_ier(token)
char   token[];
{
  char     word[MAXWORDLEN + 1], altword[MAXWORDLEN + 1], root[MAXWORDLEN + 1],
           pttrn[MAXPTRNS+1], cptrn[MAXPTRNS+1];
  int      wdlen;
  int      alt_r, alt_er, alt_ier, Txtwd_stored;
  boolean  svsc, svdc;


  Txtwd_stored = FALSE;
  strcpy(word, token);
  wdlen = strlen(word);

  if (Suffix_r(word, root, pttrn))
  {
    solprb();

    if (getval(0, "proper_wordform"))
    {
     /* printf("\nInterpretation %d: \n", itprt);
      printf("word: %s; root: %s; suffix: r; pattern: %s\n", word, root, pttrn);
      for (i = ISWFIDX; i < (NOTWFIDX + 10); i ++)
      {
        if (getval(i, var))
        {
          printf("%s\n", var);
        };
      };*/

      is_wf = iswf_code();
      not_wf = notwf_code();
      
      if (cmb_sfx_ptrn("er", pttrn, cptrn)) {
        char pt[MAXPTRNS + 1];

        if (Find_Word(word, pt)) {
          if (pt[0] != 'U') {
            strcat(pt, cptrn);
            strcpy(cptrn, pt);
          }
        }
        inner_form(word, root, " ", cptrn, Txt_Alt, Fnd_Not,
                   is_wf, not_wf, 0);   
      }
      else {
        inner_form(word, root, "r", pttrn, Txt_Alt, Fnd_Not, 
                   is_wf, not_wf, 0);   
      }

      Txtwd_stored = TRUE;

      Txt_Alt = 'B';
      
      rstprb("A");
    }
    else
    {
      if (getval(0, "violate_spelling"))
      {
        svsc = getval(0, "ip_rtsf(svsc)");
        svdc = getval(0, "ip_rtsf(svdc)");
        strcpy(altword, word);
       
        alt_er = FALSE;
        alt_ier = FALSE;

        rstprb("A");
                         
        if ((altword[wdlen - 2] == 'y') && (! Is_vowel(altword[wdlen - 3])))
        {
          altword[wdlen - 2] = 'i';
          altword[wdlen - 1] = 'e';
          altword[wdlen] = 'r';
          altword[wdlen + 1] = '\0';
          alt_ier = Suffix_ier(altword, root, pttrn);
        }
        else
        {
          if (svsc)
          { 
            altword[wdlen - 1] = altword[wdlen - 2];
            altword[wdlen] = 'e';
            altword[wdlen + 1] = 'r';
            altword[wdlen + 2] = '\0';
          }
          else
          {
            if (svdc)
            {
              altword[wdlen - 2] = 'e';
              altword[wdlen - 1] = 'r';
              altword[wdlen] = '\0';
            }
            else /* 'e' is missing */
            {
              altword[wdlen - 1] = 'e';
              altword[wdlen] = 'r';
              altword[wdlen + 1] = '\0';
            };   
          };

          
          alt_er = Suffix_er(altword, root, pttrn);
        };

        if (alt_er || alt_ier)
        {
          solprb();

          if (getval(0, "proper_wordform"))
          {
            inner_form(word, " ", " ", " ", Txt_Alt, Fnd_Not, 0, 0, 0);
            Txt_Alt = 'A';
            Txtwd_stored = TRUE;

            is_wf = iswf_code();
            not_wf = notwf_code();
      
            /*printf("\nInterpretation %d: \n", itprt);*/
            if (alt_er)
            {
              /*printf("word: %s; root: %s; suffix: er; pattern:  %s\n", 
                      altword, root, pttrn);*/
              if (cmb_sfx_ptrn("er", pttrn, cptrn)) {
                char pt[MAXPTRNS + 1];

                if (Find_Word(word, pt)) {
                  if (pt[0] != 'U') {
                    strcat(pt, cptrn);
                    strcpy(cptrn, pt);
                  }
                }
                inner_form(altword, root, " ", cptrn, Txt_Alt, 'F', 
                           is_wf, not_wf, SPELLING);
              }
              else {
                inner_form(altword, root, "er", pttrn, Txt_Alt, 'F', 
                           is_wf, not_wf, SPELLING);
              }
            }
            else
            {
              /*printf("word: %s; root: %s; suffix: ier; pattern:  %s\n", 
                      altword, root, pttrn);*/
              if (cmb_sfx_ptrn("er", pttrn, cptrn)) {
                char pt[MAXPTRNS + 1];

                if (Find_Word(word, pt)) {
                  if (pt[0] != 'U') {
                    strcat(pt, cptrn);
                    strcpy(cptrn, pt);
                  }
                }
                inner_form(altword, root, " ", cptrn, Txt_Alt, 'F', 
                           is_wf, not_wf, SPELLING);
              }
              else {
                inner_form(altword, root, "ier", pttrn, Txt_Alt, 'F', 
                           is_wf, not_wf, SPELLING);
              }
 
            };

            /*for (i = ISWFIDX; i < (NOTWFIDX + 10); i ++)
            {
              if (getval(i, var))
              {
                printf("%s\n", var);
              };
            };
            printf("violate_spelling\n");*/
          };
                             
          rstprb("A");
        };
      }
      else
      {
        rstprb("A");
      };
    };                      
  };
                           
  if (word[wdlen - 2] == 'e')
  {
    if (Suffix_er(word, root, pttrn))
    {
      solprb();

      if (getval(0, "proper_wordform"))
      {
        /*printf("\nInterpretation %d: \n", itprt);
        printf("word: %s; root: %s; suffix: er; pattern: %s\n", 
                word, root,pttrn);
        for (i = ISWFIDX; i < (NOTWFIDX + 10); i ++)
        {
          if (getval(i, var))
          {
            printf("%s\n", var);
          };
        };*/
       
        is_wf = iswf_code();
        not_wf = notwf_code();
      
        if (cmb_sfx_ptrn("er", pttrn, cptrn)) {
          char pt[MAXPTRNS + 1];

          if (Find_Word(word, pt)) {
            if (pt[0] != 'U') {
              strcat(pt, cptrn);
              strcpy(cptrn, pt);
            }
          }
          inner_form(word, root, " ", cptrn, Txt_Alt, Fnd_Not, 
                     is_wf, not_wf, 0);
        }
        else {
          inner_form(word, root, "er", pttrn, Txt_Alt, Fnd_Not, 
                     is_wf, not_wf, 0);
        }

        if (Txt_Alt == 'T')
        {
          Txt_Alt = 'B';
        };
               
        rstprb("A");
      }
      else
      {
        if (getval(0, "violate_spelling"))
        {
          svsc = getval(0, "ip_rtsf(svsc)");
          strcpy(altword, word);
        
          alt_r = FALSE;
          alt_er = FALSE;
          alt_ier = FALSE;

          rstprb("A");
                         
          if ((altword[wdlen - 3] == 'y') && (! Is_vowel(altword[wdlen - 4])))
          {
            altword[wdlen - 3] = 'i';
            alt_ier = Suffix_ier(altword, root, pttrn);
          }
          else
          {
            if (altword[wdlen - 3] == 'e')
            {
              altword[wdlen - 2] = 'r';
              altword[wdlen - 1] = '\0';
              alt_r = Suffix_r(altword, root, pttrn);
            }
            else
            {
              if(svsc)
              {
                altword[wdlen - 2] = altword[wdlen - 3];
                altword[wdlen - 1] = 'e';
                altword[wdlen] = 'r';
                altword[wdlen + 1] = '\0';
              }
              else  /* ip_rtsf(svdc) == TRUE */
              {
                altword[wdlen - 3] = 'e';
                altword[wdlen - 2] = 'r';
                altword[wdlen - 1] = '\0';
              };

              alt_er = Suffix_er(altword, root, pttrn);
            };
          };

          if (alt_r || alt_er || alt_ier)
          {
            solprb();

            if (getval(0, "proper_wordform"))
            {
              if (! Txtwd_stored)
              {
                inner_form(word, " ", " ", " ", Txt_Alt, Fnd_Not, 0, 0, 0);
                Txt_Alt = 'A';
                Txtwd_stored = TRUE;
              };

              is_wf = iswf_code();
              not_wf = notwf_code();
      

              /*printf("\nInterpretation %d: \n", itprt);*/
              if (alt_r)
              {
                /*printf("word: %s; root: %s; suffix: r; pattern:  %s\n", 
                        altword, root, pttrn);*/
                if (cmb_sfx_ptrn("er", pttrn, cptrn)) {
                  char pt[MAXPTRNS + 1];

                  if (Find_Word(word, pt)) {
                    if (pt[0] != 'U') {
                      strcat(pt, cptrn);
                      strcpy(cptrn, pt);
                    }
                  }
                  inner_form(altword, root, " ", cptrn, Txt_Alt, 'F', 
                             is_wf, not_wf, SPELLING);
                }
                else {
                  inner_form(altword, root, "r", pttrn, Txt_Alt, 'F', 
                             is_wf, not_wf, SPELLING);
                }
              }
              else
              {
                if (alt_er)
                {
                  /*printf("word: %s; root: %s; suffix: er; pattern:  %s\n", 
                          altword, root, pttrn);*/
                  if (cmb_sfx_ptrn("er", pttrn, cptrn)) {
                    char pt[MAXPTRNS + 1];

                    if (Find_Word(word, pt)) {
                      if (pt[0] != 'U') {
                        strcat(pt, cptrn);
                        strcpy(cptrn, pt);
                      }
                    }
                    inner_form(altword, root, " ", cptrn, Txt_Alt, 'F', 
                               is_wf, not_wf, SPELLING);
                  } 
                  else {
                    inner_form(altword, root, "er", pttrn, Txt_Alt, 'F', 
                               is_wf, not_wf, SPELLING);
                  }
                }
                else
                {
                  /*printf("word: %s; root: %s; suffix: ier; pattern:  %s\n", 
                          altword, root, pttrn);*/
                  if (cmb_sfx_ptrn("er", pttrn, cptrn)) {
                    char pt[MAXPTRNS + 1];

                    if (Find_Word(word, pt)) {
                      if (pt[0] != 'U') {
                        strcat(pt, cptrn);
                        strcpy(cptrn, pt);
                      }
                    }
                    inner_form(altword, root, " ", cptrn, Txt_Alt, 'F', 
                               is_wf, not_wf, SPELLING);
                  }
                  else {
                    inner_form(altword, root, "ier", pttrn, Txt_Alt, 'F', 
                               is_wf, not_wf, SPELLING);
                  }
                }
              }

              /*for (i = ISWFIDX; i < (NOTWFIDX + 10); i ++)
              {
                if (getval(i, var))
                {
                 printf("%s\n", var);
                };
              };
              printf("violate_spelling\n");*/
            };
                             
            rstprb("A");

          };
        }
        else
        {
          rstprb("A");
        };
      };
    };
  };
                     
  if (word[wdlen - 3] == 'i')
  {
    if (Suffix_ier(word, root, pttrn))
    {
      solprb();

      if (getval(0, "proper_wordform"))
      {
        /*printf("\nInterpretation %d: \n", itprt);
        printf("word: %s; root: %s; suffix: ier; pattern:  %s\n",
                word, root, pttrn);*/
        /*for (i = ISWFIDX; i < (NOTWFIDX + 10); i ++)
        {
          if (getval(i, var))
          {
            printf("%s\n", var);
          };
        };*/
         
        is_wf = iswf_code();
        not_wf = notwf_code();
      
        if (cmb_sfx_ptrn("er", pttrn, cptrn)) {
          char pt[MAXPTRNS + 1];

          if (Find_Word(word, pt)) {
            if (pt[0] != 'U') {
              strcat(pt, cptrn);
              strcpy(cptrn, pt);
            }
          }
          inner_form(word, root, " ", cptrn, Txt_Alt, Fnd_Not, 
                     is_wf, not_wf, 0);
        }
        else {
          inner_form(word, root, "ier", pttrn, Txt_Alt, Fnd_Not, 
                     is_wf, not_wf, 0);
        }

        if (Txt_Alt == 'T')
        {
          Txt_Alt = 'B';
        };

                    
        rstprb("A");
      }
      else
      {
        if (getval(0, "violate_spelling"))
        {
          strcpy(altword, word);
          altword[wdlen - 3] = 'y';
                                                 
          rstprb("A");
  
          if (Suffix_er(altword, root, pttrn))
          {
            solprb();

            if (getval(0, "proper_wordform"))
            {
              if (! Txtwd_stored)
              {
                inner_form(word, " ", " ", " ", Txt_Alt, Fnd_Not, 0, 0, 0);
                Txt_Alt = 'A';
                Txtwd_stored = TRUE;
              };

              is_wf = iswf_code();
              not_wf = notwf_code();
      
              /*printf("\nInterpretation %d: \n", itprt);
              printf("word: %s; root: %s; suffix: er; pattern:  %s\n", 
                      altword, root, pttrn);*/

              if (cmb_sfx_ptrn("er", pttrn, cptrn)) {
                char pt[MAXPTRNS + 1];

                if (Find_Word(word, pt)) {
                  if (pt[0] != 'U') {
                    strcat(pt, cptrn);
                    strcpy(cptrn, pt);
                  }
                }
                inner_form(altword, root, " ", cptrn, Txt_Alt, 'F', 
                           is_wf, not_wf, SPELLING);
              }
              else {
                inner_form(altword, root, "er", pttrn, Txt_Alt, 'F', 
                           is_wf, not_wf, SPELLING);
              }


              /*for (i = ISWFIDX; i < (NOTWFIDX + 10); i ++)
              {
                if (getval(i, var))
                {
                  printf("%s\n", var);
                };
              };
              printf("violate_spelling\n");*/
            };                 
              
            rstprb("A");

          };
        }
        else
        {
          rstprb("A");
        };
      };
    };
  };

} /* Suffix_r_er_ier */


int Suffix_st(word, rootst, pttrnst)
char  word[], rootst[], pttrnst[];
{

  int          len, wdlen, i, irglar;
  char         cname[MAXPTRNS+1][7], ch1, ch2; 
  static char  var[129];
  int          found_st;
 
  found_st = FALSE;
  
  rootst[0] = '\0';
  pttrnst[0] = '\0';
 
  wdlen = strlen(word);

  strcpy(rootst, word);
  rootst[wdlen - 2] = '\0';
  switch(Is_sglvwl_sglcnsnt(rootst, "est"))
  {
    case 0: 
            if ((found_st = Find_Word(rootst, pttrnst)))
            {
              len = Class_Name(pttrnst, cname, &irglar);

              for (i = 0; i < len; i++)
              {
                strcpy(var, "ip_clsf(");
                strcat(var, cname[i]);
                strcat(var, ",st)");

                mstvar(var, 0, "T");
              };

              len = strlen(rootst) - 1;
              ch1 = rootst[len - 1];
              ch2 = rootst[len];
              switch(ch2)
              {
                case 'e':  strcpy(var, "ip_rtsf(e)");
                           mstvar(var, 0, "T");
                           break;
                case 'y':  if (! Is_vowel(ch1))
                           {
                             strcpy(var, "ip_rtsf(cy)");
                             mstvar(var, 0, "T");
                           };
                          break;
              };   
            }
            else
            {
              rootst[0] = '\0';
              pttrnst[0] = '\0'; 
            };
            break;

    case 1: 
            if ((found_st = Find_Word(rootst, pttrnst)))
            {
              len = Class_Name(pttrnst, cname, &irglar);

              for (i = 0; i < len; i++)
              {
                strcpy(var, "ip_clsf(");
                strcat(var, cname[i]);
                strcat(var, ",st)");

                mstvar(var, 0, "T");
              };
 
              strcpy(var, "ip_rtsf(svsc)");
              mstvar(var, 0, "T");

            }
            else
            {
              rootst[0] = '\0';
              pttrnst[0] = '\0'; 
            };
            break;

    case 2: 
            rootst[wdlen - 3] = '\0';
            if ((found_st = Find_Word(rootst, pttrnst)))
            {
              len = Class_Name(pttrnst, cname, &irglar);

              for (i = 0; i < len; i++)
              {
                strcpy(var, "ip_clsf(");
                strcat(var, cname[i]);
                strcat(var, ",st)");

                mstvar(var, 0, "T");
              };
              strcpy(var, "ip_rtsf(svdc)");
              mstvar(var, 0, "T");

            }
            else
            {
              rootst[wdlen - 3] = rootst[wdlen - 4];
              rootst[wdlen - 2] = '\0';
              if ((found_st = Find_Word(rootst, pttrnst)))
              {
                len = Class_Name(pttrnst, cname, &irglar);

                for (i = 0; i < len; i++)
                {
                  strcpy(var, "ip_clsf(");
                  strcat(var, cname[i]);
                  strcat(var, ",st)");

                  mstvar(var, 0, "T");
                };
              }
              else
              {
                rootst[0] = '\0';
                pttrnst[0] = '\0'; 
              };
            };
            break;

    case 3:
            rootst[wdlen - 3] = '\0';
            if ((found_st = Find_Word(rootst, pttrnst)))
            {
              len = Class_Name(pttrnst, cname, &irglar);

              for (i = 0; i < len; i++)
              {
                strcpy(var, "ip_clsf(");
                strcat(var, cname[i]);
                strcat(var, ",st)");

                mstvar(var, 0, "T");
              };
              
            }
            else
            {
              rootst[0] = '\0';
              pttrnst[0] = '\0'; 
              
            };
            break;
  };

  return(found_st);
}

int Suffix_est(word, rootest, pttrnest)
char  word[], rootest[], pttrnest[];
{
  int          len, wdlen, i, irglar;
  char         cname[MAXPTRNS+1][7], ch1, ch2; 
  static char  var[129];
  int          found_est;

  found_est = FALSE;
  
  rootest[0] = '\0';
  pttrnest[0] = '\0';
 
  wdlen = strlen(word);
  strcpy(rootest, word);
  rootest[wdlen - 3] = '\0';
  switch(Is_sglvwl_sglcnsnt(rootest, "est"))
  {
    case 0: 
            if ((found_est = Find_Word(rootest, pttrnest)))
            {  
              len = Class_Name(pttrnest, cname, &irglar);

              for (i = 0; i < len; i++)
              {
                strcpy(var, "ip_clsf(");
                strcat(var, cname[i]);
                strcat(var, ",est)");

                mstvar(var, 0, "T");
              };

              len = strlen(rootest) - 1;
              ch1 = rootest[len - 1];
              ch2 = rootest[len];
              switch(ch2)
              {
                case 'e':  strcpy(var, "ip_rtsf(e)");
                           mstvar(var, 0, "T");
                           break;
                case 'y':  if (! Is_vowel(ch1))
                           {
                             strcpy(var, "ip_rtsf(cy)");
                             mstvar(var, 0, "T");
                           };
                           break;
              };
            }
            else
            {
              rootest[0] = '\0';
              pttrnest[0] = '\0';
            };
            break;

    case 1: 
            if ((found_est = Find_Word(rootest, pttrnest)))
            {  
              len = Class_Name(pttrnest, cname, &irglar);

              for (i = 0; i < len; i++)
              {
                strcpy(var, "ip_clsf(");
                strcat(var, cname[i]);
                strcat(var, ",est)");

                mstvar(var, 0, "T");
              };

              strcpy(var, "ip_rtsf(svsc)");
              mstvar(var, 0, "T");
            }
            else
            {
              rootest[0] = '\0';
              pttrnest[0] = '\0';
            };
            break;
  
    case 2: 
            rootest[wdlen - 4] = '\0';
            if ((found_est = Find_Word(rootest, pttrnest)))
            {  
              len = Class_Name(pttrnest, cname, &irglar);

              for (i = 0; i < len; i++)
              {
                strcpy(var, "ip_clsf(");
                strcat(var, cname[i]);
                strcat(var, ",est)");

                mstvar(var, 0, "T");
              };
              strcpy(var, "ip_rtsf(svdc)");
              mstvar(var, 0, "T");

            }
            else
            {
              rootest[wdlen - 4] = rootest[wdlen - 5];
              rootest[wdlen - 3] = '\0';
              if ((found_est = Find_Word(rootest, pttrnest)))
              {  
                len = Class_Name(pttrnest, cname, &irglar);

                for (i = 0; i < len; i++)
                {
                  strcpy(var, "ip_clsf(");
                  strcat(var, cname[i]);
                  strcat(var, ",est)");

                  mstvar(var, 0, "T");
                };

              }
              else
              {
                rootest[0] = '\0';
                pttrnest[0] = '\0';
              }; 
            }; 
            break;

    case 3:
            rootest[wdlen - 4] = '\0';
            if ((found_est = Find_Word(rootest, pttrnest)))
            {  
              len = Class_Name(pttrnest, cname, &irglar);

              for (i = 0; i < len; i++)
              {
                strcpy(var, "ip_clsf(");
                strcat(var, cname[i]);
                strcat(var, ",est)");

                mstvar(var, 0, "T");
              };
            }
            else
            {
              rootest[0] = '\0';
              pttrnest[0] = '\0';
           
            }; 
            break;
  };

  return(found_est);

}


int Suffix_iest(word, rootiest, pttrniest)
char  word[], rootiest[], pttrniest[];
{

  int          len, wdlen, i, irglar;
  char         cname[MAXPTRNS+1][7], ch1; 
  static char  var[129];
  int          found_iest;

  found_iest = FALSE;
  
  rootiest[0] = '\0';
  pttrniest[0] = '\0';
 
  wdlen = strlen(word);
  strcpy(rootiest, word);
  rootiest[wdlen - 4] = 'y';
  rootiest[wdlen - 3] = '\0';
  if ((found_iest = Find_Word(rootiest, pttrniest)))
  {  
    len = Class_Name(pttrniest, cname, &irglar);

    for (i = 0; i < len; i++)
    {
      strcpy(var, "ip_clsf(");
      strcat(var, cname[i]);
      strcat(var, ",iest)");

      mstvar(var, 0, "T");
    };


    len = strlen(rootiest) - 1;
    ch1 = rootiest[len - 1];
    if (Is_vowel(ch1))
    {
      strcpy(var, "ip_rtsf(vy)");
      mstvar(var, 0, "T");
    };
      
  }
  else
  {
    rootiest[0] = '\0';
    pttrniest[0] = '\0'; 
  };

  return(found_iest);

}
  

void  Suffix_st_est_iest(token)

char   token[];


{
  char     word[MAXWORDLEN + 1], altword[MAXWORDLEN + 1], root[MAXWORDLEN + 1],
           pttrn[MAXPTRNS+1], cptrn[MAXPTRNS+1];
  int      wdlen;
  int      alt_st, alt_est, alt_iest, Txtwd_stored;
  boolean  svsc, svdc;


  
  Txtwd_stored = FALSE;
  strcpy(word, token);
  wdlen = strlen(word);

  if (Suffix_st(word, root, pttrn))
  {
    solprb();

    if (getval(0, "proper_wordform"))
    {
      /*printf("\nInterpretation %d: \n", itprt);
      printf("word: %s; root: %s; suffix: st; pattern: %s\n", word, root,pttrn);
      for (i = ISWFIDX; i < (NOTWFIDX + 10); i ++)
      {
        if (getval(i, var))
        {
          printf("%s\n", var);
        };
      };*/

      is_wf = iswf_code();
      not_wf = notwf_code();
      
      if (cmb_sfx_ptrn("est", pttrn, cptrn)) {
        inner_form(word, root, " ", cptrn, Txt_Alt, Fnd_Not,
                   is_wf, not_wf, 0);
      }
      else {
        inner_form(word, root, "st", pttrn, Txt_Alt, Fnd_Not, 
                   is_wf, not_wf, 0);
      }
      Txtwd_stored = TRUE;


      Txt_Alt = 'B';

                   
      rstprb("A");
    }
    else
    {
      if (getval(0, "violate_spelling"))
      {
        svsc = getval(0, "ip_rtsf(svsc)");
        svdc = getval(0, "ip_rtsf(svdc)");
        strcpy(altword, word);
        
        alt_est = FALSE;
        alt_iest = FALSE;

        rstprb("A");
                         
        if ((altword[wdlen - 3] == 'y') && (! Is_vowel(altword[wdlen - 4])))
        {
          altword[wdlen - 3] = 'i';
          altword[wdlen - 2] = 'e';
          altword[wdlen - 1] = 's';
          altword[wdlen] = 't';
          altword[wdlen + 1] = '\0';

          alt_iest = Suffix_iest(altword, root, pttrn);
        }
        else
        {
          if (svsc)
          { 
            altword[wdlen - 2] = altword[wdlen - 3];
            altword[wdlen - 1] = 'e';
            altword[wdlen] = 's';
            altword[wdlen + 1] = 't';
            altword[wdlen + 2] = '\0';
          }
          else
          {
            if (svdc)
            {
              altword[wdlen - 3] = 'e';
              altword[wdlen - 2] = 's';
              altword[wdlen -1] = 't';
              altword[wdlen] = '\0';
            }
            else /* 'e' is missing */
            {
              altword[wdlen - 2] = 'e';
              altword[wdlen - 1] = 's';
              altword[wdlen] = 't';
              altword[wdlen + 1] = '\0';
            };
            
          };
          
          alt_est = Suffix_est(altword, root, pttrn);
        };

        if (alt_est || alt_iest)
        {
          solprb();

          if (getval(0, "proper_wordform"))
          {
            inner_form(word, " ", " ", " ", Txt_Alt, Fnd_Not, 0, 0, 0);
            Txt_Alt = 'A';
            Txtwd_stored = TRUE;

            is_wf = iswf_code();
            not_wf = notwf_code();
      


            /*printf("\nInterpretation %d: \n", itprt);*/
            if (alt_est)
            {
              /*printf("word: %s; root: %s; suffix: est; pattern:  %s\n", 
                      altword, root, pttrn);*/
              if (cmb_sfx_ptrn("est", pttrn, cptrn)) {
                inner_form(altword, root, " ", cptrn, Txt_Alt, 'F',
                           is_wf, not_wf, SPELLING);
              }
              else {
                inner_form(altword, root, "est", pttrn, Txt_Alt, 'F', 
                           is_wf, not_wf, SPELLING);
              }
            }
            else
            {
             /* printf("word: %s; root: %s; suffix: iest; pattern:  %s\n", 
                      altword, root, pttrn);*/
              if (cmb_sfx_ptrn("est", pttrn, cptrn)) {
                inner_form(altword, root, " ", cptrn, Txt_Alt, 'F',
                           is_wf, not_wf, SPELLING);
              }
              else {
                inner_form(altword, root, "iest", pttrn, Txt_Alt, 'F', 
                           is_wf, not_wf, SPELLING);
              }
            }

            /*for (i = ISWFIDX; i < (NOTWFIDX + 10); i ++)
            {
              if (getval(i, var))
              {
                printf("%s\n", var);
              };
            };
            printf("violate_spelling\n");*/
          };
                             
          rstprb("A");
        };
      }
      else
      {
        rstprb("A");
      };
    };                      
  };

                           
  if (word[wdlen - 3] == 'e')
  {
    if (Suffix_est(word, root, pttrn))
    {
      solprb();

      if (getval(0, "proper_wordform"))
      {
        /*printf("\nInterpretation %d: \n", itprt);
        printf("word: %s; root: %s; suffix: est; pattern: %s\n", 
                word, root,pttrn);
        for (i = ISWFIDX; i < (NOTWFIDX + 10); i ++)
        {
          if (getval(i, var))
          {
            printf("%s\n", var);
          };
        };*/
        
        is_wf = iswf_code();
        not_wf = notwf_code();
        
        if (cmb_sfx_ptrn("est", pttrn, cptrn)) {
          inner_form(word, root, " ", cptrn, Txt_Alt, Fnd_Not,
                     is_wf, not_wf, 0);
        }
        else {
          inner_form(word, root, "est", pttrn, Txt_Alt, Fnd_Not, 
                     is_wf, not_wf, 0);
        }

        if (Txt_Alt == 'T')
        {
          Txt_Alt = 'B';
        };

                                          
        rstprb("A");
      }
      else
      {
        if (getval(0, "violate_spelling"))
        {
          svsc = getval(0, "ip_rtsf(svsc)");
          strcpy(altword, word);
        
          alt_st = FALSE;
          alt_est = FALSE;
          alt_iest = FALSE;

          rstprb("A");
                         
          if ((altword[wdlen - 4] == 'y') && (! Is_vowel(altword[wdlen - 5])))
          {
            altword[wdlen - 4] = 'i';
            alt_iest = Suffix_iest(altword, root, pttrn);
          }
          else
          {
            if (altword[wdlen - 4] == 'e')
            {
              altword[wdlen - 3] = 's';
              altword[wdlen - 2] = 't';
              altword[wdlen - 1] = '\0';
              alt_st = Suffix_st(altword, root, pttrn);
            }
            else
            {
              if(svsc)
              {
                altword[wdlen - 3] = altword[wdlen - 4];
                altword[wdlen - 2] = 'e';
                altword[wdlen - 1] = 's';
                altword[wdlen] = 't';
                altword[wdlen + 1] = '\0';
              }
              else  /* ip_rtsf(svdc) == TRUE */
              {
                altword[wdlen - 4] = 'e';
                altword[wdlen - 3] = 's';
                altword[wdlen - 2] = 't';
                altword[wdlen - 1] = '\0';
              };

              alt_est = Suffix_est(altword, root, pttrn);
            };

          };

          if (alt_st || alt_est || alt_iest)
          {
            solprb();

            if (getval(0, "proper_wordform"))
            {
              if (! Txtwd_stored)
              {
                inner_form(word, " ", " ", " ", Txt_Alt, Fnd_Not, 0, 0, 0);
                Txt_Alt = 'A';
                Txtwd_stored = TRUE;
              };

              is_wf = iswf_code();
              not_wf = notwf_code();
      

              /*printf("\nInterpretation %d: \n", itprt);*/
              if (alt_st)
              {
                /*printf("word: %s; root: %s; suffix: st; pattern:  %s\n", 
                        altword, root, pttrn);*/
                if (cmb_sfx_ptrn("est", pttrn, cptrn)) {
                  inner_form(altword, root, " ", cptrn, Txt_Alt, 'F', 
                         is_wf, not_wf, SPELLING);
                }
                else {
                  inner_form(altword, root, "st", pttrn, Txt_Alt, 'F', 
                             is_wf, not_wf, SPELLING);
                }
              }
              else
              {
                if (alt_est)
                {
                  /*printf("word: %s; root: %s; suffix: est; pattern:  %s\n", 
                          altword, root, pttrn);*/
                  if (cmb_sfx_ptrn("est", pttrn, cptrn)) {
                    inner_form(altword, root, " ", cptrn, Txt_Alt, 'F', 
                               is_wf, not_wf, SPELLING);
                  }
                  else {
                    inner_form(altword, root, "est", pttrn, Txt_Alt, 'F', 
                               is_wf, not_wf, SPELLING);
                  }
                }
                else
                {
                  /*printf("word: %s; root: %s; suffix: iest; pattern:  %s\n", 
                          altword, root, pttrn);*/
                  if (cmb_sfx_ptrn("est", pttrn, cptrn)) {
                    inner_form(altword, root, " ", cptrn, Txt_Alt, 'F', 
                               is_wf, not_wf, SPELLING);
                  }
                  else {
                    inner_form(altword, root, "iest", pttrn, Txt_Alt, 'F', 
                               is_wf, not_wf, SPELLING);
                  }

                };
              };

             /* for (i = ISWFIDX; i < (NOTWFIDX + 10); i ++)
              {
                if (getval(i, var))
                {
                 printf("%s\n", var);
                };
              };
              printf("violate_spelling\n");*/
            };
                             
            rstprb("A");

          };
        }
        else
        {
          rstprb("A");
        };
      };
    };
  };
                    
  if (word[wdlen - 4] == 'i')
  {
    if (Suffix_iest(word, root, pttrn))
    {
      solprb();

      if (getval(0, "proper_wordform"))
      {
        /*printf("\nInterpretation %d: \n", itprt);
        printf("word: %s; root: %s; suffix: iest; pattern:  %s\n",
                word, root, pttrn);
        for (i = ISWFIDX; i < (NOTWFIDX + 10); i ++)
        {
          if (getval(i, var))
          {
            printf("%s\n", var);
          };
        };*/
         
        is_wf = iswf_code();
        not_wf = notwf_code();
        
        if (cmb_sfx_ptrn("est", pttrn, cptrn)) {
          inner_form(word, root, " ", cptrn, Txt_Alt, Fnd_Not, 
                     is_wf, not_wf, 0);
        }
        else {
          inner_form(word, root, "iest", pttrn, Txt_Alt, Fnd_Not, 
                     is_wf, not_wf, 0);
        }

        if (Txt_Alt == 'T')
        {
          Txt_Alt = 'B';
        };

                                                 
        rstprb("A");
      }
      else
      {
        if (getval(0, "violate_spelling"))
        {
          strcpy(altword, word);
          altword[wdlen - 4] = 'y';
                                                
          rstprb("A");
  
          if (Suffix_est(altword, root, pttrn))
          {
            solprb();

            if (getval(0, "proper_wordform"))
            {
              if (! Txtwd_stored)
              {
                inner_form(word, " ", " ", " ", Txt_Alt, Fnd_Not, 0, 0, 0);
                Txt_Alt = 'A';
                Txtwd_stored = TRUE;
              };

              is_wf = iswf_code();
              not_wf = notwf_code();
      

              /*printf("\nInterpretation %d: \n", itprt);
              printf("word: %s; root: %s; suffix: est; pattern:  %s\n", 
                      altword, root, pttrn);*/

              if (cmb_sfx_ptrn("est", pttrn, cptrn)) {
                inner_form(altword, root, " ", cptrn, Txt_Alt, 'F', 
                           is_wf, not_wf, SPELLING);
              }
              else {
                inner_form(altword, root, "est", pttrn, Txt_Alt, 'F', 
                           is_wf, not_wf, SPELLING);
              }


              /*for (i = ISWFIDX; i < (NOTWFIDX + 10); i ++)
              {
                if (getval(i, var))
                {
                  printf("%s\n", var);
                };
              };
              printf("violate_spelling\n");*/
            };                 
              
            rstprb("A");

          };
        }
        else
        {
          rstprb("A");
        };
      };
    };
  };


} /* Suffix_st_est_iest */


/***************************************************************************/
/*Function to check if the word is terminated w/ a special suffix(ies, ied,*/
/*ier, iest)                                                               */
/***************************************************************************/
boolean  is_spcl_sffx(token)
char   token[];
{
  int   len;
  char  ch;

  len = strlen(token);
  if (len > 3)
  {
    ch = token[len - 1];
    switch (ch)
    {
      case 'd':
      case 's':
      case 'r':
                if (token[len - 2] == 'e') 
                {
                  return(TRUE);
                }
                else
                {
                  return(FALSE);
                };

      case 't':
                if ((token[len - 2] == 's') && 
                    (token[len - 3] == 'e'))
                {
                  return(TRUE);
                }
                else
                {
                  return(FALSE);
                };

      case 'g':
                if ((token[len - 2] == 'n') && 
                    (token[len - 3] == 'i'))
                {
                  return(TRUE);
                }
                else
                {
                  return(FALSE);
                };

      default:
                return(FALSE);
    };
  };

  return(FALSE);

}


void  Find_wdform(token)
char  token[];
{
  int  len;

  if ((Fnd_Not == 'F') && (! is_spcl_sffx(token)))
  {
    return;
  };

  len = strlen(token);
  switch(token[len - 1])
  {
    case 's': Suffix_s_es_ies(token); 
              break;
    case 'd': Suffix_d_ed_ied(token);
              break;
    case 'g': if ((token[len - 3] == 'i') && (token[len - 2] == 'n'))
              {
                Suffix_ING(token);  
              };
              break;
    case 'r': Suffix_r_er_ier(token);
              break;
    case 't': if (token[len - 2] == 's')
              { 
                Suffix_st_est_iest(token);
              };
              break;
   };
 }       





/*---------------------------------------------------------------------

  cmb_sfx_ptrn  --  combine suffix and patterns into new patterns

    input  -- sfx: suffix (es, ed, er, est, ing)
              ptrns1: old patterns
    output -- ptrns2: new patterns

  function returns TRUE if they are combined successfully, FALSE otherwise

----------------------------------------------------------------------*/
boolean cmb_sfx_ptrn(sfx, ptrns1, ptrns2)
char  *sfx, *ptrns1, *ptrns2;
{
  int  len, i, j;
  char pt;

  len = strlen(ptrns1);
  if (strcmp(sfx, "es") == 0) {
    int occured[3];

    j = 0;
    occured[0] = occured[1] = occured[2] = 0;
    for (i = 0; i < len; i++) {
      pt = ptrns1[i];
      switch(pt) {
        case 'n':
        case 'g':
        case 'G': if (!occured[0]) {
                    ptrns2[j++] = 'N';
                    occured[0] = 1;
                  }
                  break;
        case 't':
        case 'u': if (!occured[1]) {
                    ptrns2[j++] = 'T';
                    occured[1] = 1;
                  }
                  break;
        case 'i':
        case 'j': if (!occured[2]) {
                    ptrns2[j++] = 'I';
                    occured[2] = 1;
                  }
                  break;
        case 'l': ptrns2[j++] = 'L';
                  break;
      }
    }
    if (j == 0) return FALSE;
    ptrns2[j] = '\0';
    return TRUE;
  }
  
  if (strcmp(sfx, "ed") == 0) {
    int occured[2];

    j = 0;
    occured[0] = occured[1] = 0;
    for (i = 0; i < len; i++) {
      pt = ptrns1[i];
      switch(pt) {
        case 't': if (!occured[0]) {
                    ptrns2[j++] = 'v';
                    ptrns2[j++] = 'V';
                    occured[0] = 1;
                  }
                  break;
        case 'i': if (!occured[1]) {
                    ptrns2[j++] = 'k';
                    ptrns2[j++] = 'K';
                    occured[1] = 1;
                  }
                  break;
        case 'l': ptrns2[j++] = 'O';
                  ptrns2[j++] = 'Q';
      }
    }
    if (j == 0) return FALSE;
    ptrns2[j] = '\0';
    return TRUE;
  }

  if (strcmp(sfx, "ing") == 0) {
    int occured[2];

    j = 0;
    occured[0] = occured[1] = 0;
    for (i = 0; i < len; i++) {
      pt = ptrns1[i];
      switch(pt) {
        case 't':
        case 'u': if (!occured[0]) {
                    ptrns2[j++] = 'g';
                    occured[0] = 1;
                  }
                  break;
        case 'i':
        case 'j': if (!occured[1]) {
                    ptrns2[j++] = 'G';
                    occured[1] = 1;
                  }
                  break;
        case 'l': ptrns2[j++] = 'R';
      }
    }
    if (j == 0) return FALSE;
    ptrns2[j] = '\0';
    return TRUE;
  }
  
  if (strcmp(sfx, "er") == 0) {
    int occured[2];

    j = 0;
    occured[0] = occured[1] = 0;
    for (i = 0; i < len; i++) {
      pt = ptrns1[i];
      switch(pt) {
        case 'a': if (!occured[0]) {
                    ptrns2[j++] = 'f';
                    occured[0] = 1;
                  }
                  break;
        case 'y': if (!occured[1]) {
                    ptrns2[j++] = 'm';
                    occured[1] = 1;
                  }
                  break;
      }
    }
    if (j == 0) return FALSE;
    ptrns2[j] = '\0';
    return TRUE;
  }
  
  if (strcmp(sfx, "est") == 0) {
    int occured[2];

    j = 0;
    occured[0] = occured[1] = 0;
    for (i = 0; i < len; i++) {
      pt = ptrns1[i];
      switch(pt) {
        case 'a': if (!occured[0]) {
                    ptrns2[j++] = 'F';
                    occured[0] = 1;
                  }
                  break;
        case 'y': if (!occured[1]) {
                    ptrns2[j++] = 'M';
                    occured[1] = 1;
                  }
                  break;
      }
    }
    if (j == 0) return FALSE;
    ptrns2[j] = '\0';
    return TRUE;
  }
  return FALSE;
}



      
               
