#include <stdlib.h>
#include <string.h>
#include     "create.h"
#include     "HashFnct.h"
 
#define  BIDX     "bckt.idx"
#define  WORDDAT  "word.dat"

 

struct         cft {
                     int     fnt;
                     int     tcft;
                     int     mcft;
                   };


struct   BcktIdxEnt  Bindex[SIZEOFWORDBK];
char                 prefix[PREFIXLEN + 1], Word[MAXWORDLEN + 1], pattern[10];
unsigned long int    idx;
int                  max, conflict;


FILE *wddat, *bidx; 





int  GetBcktIdx()

{

  unsigned   i, val;
  



  val = BcktHash(prefix);
  i = 0;
/*printf("hashvalue1 %d\n", val);*/
/*printf("prefix %s\n", wordbk[val].bcktnm);*/
  while ((strcmp(Bindex[val].bcktnm, prefix) != 0) && (i <= MAXBKCONFLICT))
  {
    if (Bindex[val].bcktnm[0] == '\0')
    {
      i = MAXBKCONFLICT;
    };

    val = (val + 1) % SIZEOFWORDBK;
    i++;
  };

  if (i > MAXBKCONFLICT)
  {
    return(-1);
  }
  else
  {
    return(val);
  };
}







void  CheckBckt(fnct, num, size, buffer)

int       fnct;
unsigned  num;
unsigned  size;
int       buffer[];




{
  int       i, c;
  unsigned  val; 
  char      ch;

  


  for (i = 0; i < size; i ++)
  {
    buffer[i] = 0;
  };

  max = 0;
  conflict = 0;

/*  printf("Using HashFnct%d   ", fnct);*/

  for (i = 0; i < num; i ++)
  {
    fscanf(wddat, "%s %s\n", Word, pattern);
    idx = idx + strlen(Word) + strlen(pattern) + 2;
 /* printf("word %s  idx %ld\n", Word, idx);*/

    switch(fnct)
    {
      case  1:  val = WordHash1(Word, size);
                break;
      case  2:  val = WordHash2(Word, size);
                break;
      case  3:  val = WordHash3(Word, size);
                break;
      case  4:  val = WordHash4(Word, size);
                break;
      case  5:  val = WordHash5(Word, size);
                break;

    };


    c = 0;

    if (buffer[val] != 0)
    {
      conflict ++;
    };

    while (buffer[val] != 0)
    {
      val = (val + 1) % size;
      c++;
    };
    if (max < c)
    {  
      max = c;
    };

    buffer[val] = strlen(Word);

  };

 /* printf("total conflicts are %d    max conflict is %d\n", conflict, max);*/


}

                 


void  HashCheck(fnct, num, size)

int       fnct;
unsigned  num;
unsigned  size;

{
  int       *buffer;

  


  if (! (buffer = (int *)malloc(size * sizeof(int))))
  {
    printf("fail to allocate buffer\n");
    exit(0);
  };


  CheckBckt(fnct, num, size, buffer);

  free(buffer);

}



main()

{ 
  int                i, bcktidx, minp;
  unsigned long int  start, bcktloc, total;
  char               ch;
  unsigned           freq, size1, size2, size, p1, p2;
  char               ans[2];
  struct  cft        minfnt, min;
                     





 
  bcktloc = 0;  
  idx = 0;

 

  if ((wddat = fopen(WORDDAT, READ)) == NULL)
  {
    fprintf(stderr, "fail to open the %s \n", WORDDAT);
    exit(0);
  };



  if ((bidx = fopen(BIDX, READWRITE)) == NULL)
  {
    fprintf(stderr, "fail to open the %s \n", BIDX);
    exit(0);
  };

  ReadSucc = fread(Bindex, sizeof(Bindex), 1, bidx);
  if (! ReadSucc)
  {
    fprintf(stderr, "fail to read from %s\n", BIDX);
    exit(0);
  };

  



  total = 0;
  while (total < NUMOFWORDS)
  {
   
    fscanf(wddat, "%s %s\n", Word, pattern);
    idx =  idx + strlen(Word) + strlen(pattern) + 2;
/*printf("word %s  idx %ld\n", Word, idx);*/
    total ++;
 
  
    strncpy(prefix, Word, PREFIXLEN);
    while ((i = strlen(prefix)) < PREFIXLEN)
    {
      prefix[i] = ' ';
      prefix[i + 1] = '\0';
    };


    if ((bcktidx = GetBcktIdx()) == -1)
    {
      printf("there is no prefix %s in %s for word %s\n", prefix, BIDX,Word);
      printf("total %ld\n", total);
      exit(0);
    };

    freq = Bindex[bcktidx].freq;


    if ((Bindex[bcktidx].bksize != 0) && (Bindex[bcktidx].fnct != ' '))
    {
      printf("bucket %s has been fixed; freq %d,  size %d,  fnct %c, loc%ld\n", 
              prefix, freq, Bindex[bcktidx].bksize, Bindex[bcktidx].fnct,
              Bindex[bcktidx].bkloc);
      for (i = 1; i < freq; i ++)
      {
        fscanf(wddat, "%s %s\n", Word, pattern);
        idx = idx + strlen(Word) + strlen(pattern) + 2;
        total ++;
      };
  
      bcktloc = bcktloc + Bindex[bcktidx].bksize;

      continue;
    };




    if (freq == 1)
    {
      Bindex[bcktidx].fnct = '1';
      Bindex[bcktidx].bksize = freq;
      Bindex[bcktidx].bkloc = bcktloc;
      Bindex[bcktidx].maxcnft = 0;


      bcktloc = bcktloc + freq;
      printf("bucket %s has been fixed; freq %d,  size %d,  fnct %c\n", 
              prefix, freq, Bindex[bcktidx].bksize, Bindex[bcktidx].fnct);

      continue;
    };


    printf("now fix bucket %s\n", prefix);
    printf("the freq is %d\n", freq);
    start = idx - strlen(Word) - strlen(pattern) - 2;
    total --;
    

    do 
    {
      printf("input the size(p1, p2)\n");
      scanf("%d %d", &p1, &p2);

      size1 =  p1;
      size2 =  p2;
  
      min.tcft = freq;

      for (size = size1; size <= size2; size ++)
      {
        minfnt.tcft = freq;

        for (i = 1; i < 5; i++)
        {
          idx = start;
          fseek(wddat, idx, 0);

          HashCheck(i, freq, size);

          if (minfnt.tcft > conflict)  
          {
            minfnt.fnt = i;
            minfnt.tcft = conflict;
            minfnt.mcft = max;
          };

        };

        if (minfnt.tcft < min.tcft)
        {
          min.fnt = minfnt.fnt;
          min.tcft = minfnt.tcft;
          min.mcft = minfnt.mcft;
          minp = size;
        };
      };

      printf("with percentage %d,  size %d,  fnct %d,  total conflict %d,  max conflict %d\n", (minp - freq) * 100 / freq,  minp, min.fnt, min.tcft, min.mcft);
      
      printf("would you try again?(y or n)\n");
      scanf("%s", ans);

    } while (strcmp(ans, "y") == 0);

    printf("please input the fixed hash fnct(1, 2, 3, 4)\n\n");
    scanf("%s", ans);
    Bindex[bcktidx].fnct = ans[0];

    printf("please input the fixed bckt size\n\n");
    scanf("%d", &p1);
    Bindex[bcktidx].bksize = p1;
    Bindex[bcktidx].bkloc = bcktloc;

    printf("please input the max conflict \n\n");
    scanf("%d", &p1);
    Bindex[bcktidx].maxcnft = p1;

    bcktloc = bcktloc + Bindex[bcktidx].bksize;

    total = total + freq;

    printf("bucket %s has been fixed; freq %d,  size %d,  fnct %c, max %d\n", 
            prefix, freq, Bindex[bcktidx].bksize, Bindex[bcktidx].fnct,
            Bindex[bcktidx].maxcnft);


    printf("would you try to fix another bucket(y or n)?\n\n");
    scanf("%s",ans );
  
    if (strcmp(ans, "n") == 0)  break;

  };

  printf("%ld  words have been processed\n\n", total);
  printf("%ld  memories are needed for word.idx\n\n", bcktloc);


  fseek(bidx, 0, 0);
  
  WriteSucc = fwrite(Bindex, sizeof(Bindex), 1, bidx);
  if (! WriteSucc)
  {
    fprintf(stderr, "fail to write into %s\n", BIDX);
    exit(0);
  };



  fclose(wddat);
  fclose(bidx);
}
  
