#include "macro.h"

#include<string.h>
#include<stdio.h>
#include<stdlib.h>
      
#define           TRUE      1      /* Boolean value TRUE */
#define           FALSE     0      /* Boolean value FALSE */ 

typedef int   boolean;

extern char   wdfm_prg[];
extern char   act_prg[];

/* Declarations for the parameters used when have macro call */

static char name[128+1]="";
static char state[2]="";
static char type[5]="";
static long value[8]={0,0,0,0,0,0,0,0};
static short errcde[2]={0,0};



void  inzprb()

{
  PRGNAME_ARRAY prgname[3];

  strcpy(prgname[0], act_prg);
  strcpy(prgname[1], wdfm_prg);
  strcpy(prgname[2], "");
  value[0] = 1;
  inz_prb(prgname, name, state, type, value, errcde);
}


/**************************************************************************/
/*  This is the function to execute the macro ret_prb.                    */
/**************************************************************************/
void  retprb(prbname)
char  prbname[];
{
  strcpy(name, prbname);
  ret_prb(name, state, type, value, errcde);
}
    
/**************************************************************************/
/*  This is the function to execute the macro mst_var.                    */
/**************************************************************************/
void  mstvar(var, idx, val)
char         var[];
long         idx;
char         val[];
{
  value[0] = idx;
  strcpy(state, val);
  if (idx == 0)
  {
    strcpy(name, var);
  };
  
  mst_var(name, state, type, value, errcde);
}

/***************************************************************************/
/*  This is the function to execute the macro mst_cls.                     */
/***************************************************************************/
void  mstcls(Cname, Code, lval, hval, chgval)
char  Cname[], Code[];
long  lval, hval, chgval;
{
  strcpy(name, Cname);
  if (lval == 0)
  {
    value[0] = 0;
    value[1] = 0;
  }
  else
  {
    value[0] = lval;
    value[1] = hval;
  };
  if (strcmp(Code, "L") == 0)
  {
    value[4] = chgval;
  };
  strcpy(state, Code);
  mst_cls(name, state, type, value, errcde);
}

/**************************************************************************/
/*  This is the function to execute the macro get_val.                    */
/**************************************************************************/
boolean  getval(idx, var)
long    idx;
char    var[];
{
  value[0] = idx;
  if (idx == 0)
  {
    strcpy(name, var);  
  };
 
  get_val(name, state, type, value, errcde);
  
  if (errcde[0] != 0)
  {
    printf("Error received from get_val: %d\n",errcde[0]);
    return FALSE;
  }
  else 
  {
    if (idx != 0) {       /* added "if" 12/17/04 to avoid   */
      strcpy(var, name);  /* segmentation error when var is */
    }                     /* specified by a constant string */
    if(strcmp(state, "T") == 0)
    {
      return(TRUE);
    }
    else
    {
      if(strcmp(state, "F") == 0)
      {
        return(FALSE);
      }
      else
      {
        printf("something wrong state = %s\n", state);
        return FALSE;
      };
    };
  };
}
              
/**************************************************************************/
/* This is the function to execute the macro sol_prb. If the problem is   */
/*  satisfiable it returns TRUE, otherwise returns FALSE.                 */
/**************************************************************************/
boolean  solprb()
{
  sol_prb(name,state,type,value,errcde);
  if (errcde[0] != 0) 
  {
    printf("Error received from sol_prb: %d\n",errcde[0]);
    return(FALSE);
  }
  else 
  {
    if (state[0] == 'S')
    {
      return(TRUE);
    }
    else 
    {
      return(FALSE);
    };
  };
}

/**************************************************************************/
/*  This is the function to execute the macro rst_prb.                    */
/**************************************************************************/
void rstprb(str)
char  str[];
{
  strcpy(state, str);
  rst_prb(name,state,type,value,errcde);
  if (errcde[0] != 0) 
  {
    printf("Error received from rst_prb: %d\n",errcde[0]);
  };
}

void Solve()

{
  solprb();
  rstprb("A"); 
}
