#include "syntx.h"

int     system_status;                     /* indicate the system status */
int     bottom_likelihood;               /* indicate the lowest likelihood 
                                           considered in syntax analysis */
char    text_name[120];          /* indicate the name of user inner text */
char    old_text_name[120];
long    text_line;               /* indicate the line number of the text */
boolean stxerr_confirmed; /* indicate there is confirmed syntax error(s) */

/*----- added on 04/06/97 -----*/
/*                             */  
boolean first_time;    /* indicate the text file is processed firts time */
/*                             */
/*-----------------------------*/

/*boolean outoftime;
int     outoftime_num;
int     simple_total;*/

main()
{
  char  ans[3];
  long  sentence_count = 0;
/*struct timeval     before, after;*/

  print_title();
  read_params(TRUE);
  inzprb();

  strcpy(text_name, "");
  strcpy(old_text_name, "");

/*----- added on 04/06/97 -----*/
/*                             */  
  first_time = FALSE;
/*                             */
/*-----------------------------*/


  while (input_text_name()) {
/*----- added on 04/06/97 -----*/
/*                             */  
   start:
/*                             */
/*-----------------------------*/
    read_params(FALSE);
    read_usr_dict();

    stxerr_confirmed = FALSE;

    if (!read_text_inner()) continue;
    read_text_stc();
    read_triple_usr();
    bottom_likelihood = SOMETIME;
/*
outoftime = FALSE;
outoftime_num = 0;
simple_total = 0;
gettimeofday(&before, NULL);
*/
    text_line = 0;
    while (syntax_checking()) {
      if (((++sentence_count) % 10) == 0) fputc('.', stderr);
    }
/*
gettimeofday(&after, NULL);
printf("total: %d;  simple total: %d;  giveup: %d; time: %ld\n",
sentence_count, simple_total, outoftime_num, 
(after.tv_sec - before.tv_sec));
*/
/*----- added on 04/06/97 -----*/
/*                             */ 
    if (!first_time) {
/*                             */
/*-----------------------------*/
      remind_user();
    }

    write_usr_dict();
    write_text_stc();
    write_triple_usr();
/*----- added on 04/06/97 -----*/
/*                             */  
    if (first_time) {
      char cmd[130];

      first_time = FALSE;
      sprintf(cmd, "rm -f %s.err", text_name);
      system(cmd);
      goto start;
    }
/*                             */
/*-----------------------------*/
  }
}


