/*  first record of trparms.h***** */
/*
 * *******************************************************
 *  defines parameters for translat module
 * *******************************************************
 */
#define setmax 500
/*
 *                   max number of sets
 */
#define prdmax 5000
/*
 *                   max number of predicates
 */
#define eltmax 5000  /* max number of elements for set,      */
                    /* function, predicate                  */
/*
 */
#define qntmax 3    /* max number of quantified variables   */
/*
 */
#define whrmax 3    /* max number of where statements       */
/*
 */
#define mwemax 40   /* max number of warnings/errors after  */
                    /* which writing of such messages to    */
                    /* screen is stopped                    */
/*
 */
#define camax 500000 /* max number of cnf literals          */
/*
 */
#define crmax 10000  /* max number of cnf clauses            */
/*
 */
#define cvmax 10000  /* max number of cnf variables          */
/*
 */
#define busmax 60*cvmax /* dimension of bulk arrays         */
                    /* replacing devices 12 and 13          */
/*
 */
#define bufmax 2    /* number of bulk arrays                */
                    /* ( = number of devices replaced by    */
                    /*  bulk arrays)                        */
/*
 */
#define vnamln 58  /* propositional variable length */
/*
 */
#define enamln 58  /* element name length           */
/*
 */
#define rnamln 58  /* user defined row name length  */
/*
 */
#define ridtln 58  /* row identifier length         */
/*
 */
#define numlen  8  /* length of an ascii number     */
                   /*  (true/false cost)            */
/*
 */
#define bchmax ridtln*cvmax  /* max string length   */
                             /* for buchr array     */
/*  last record of trparms.h****** */
